PROGRAM_NAME='Rane VIA10 Netlinx Demo,Rev 1.AXS'
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 08/14/2001 AT: 15:21:18               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 10/12/2001 AT: 16:55:58         *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 10/03/2001                              *)
(*                                                         *)
(*  Note: This program is only supported in Netlinx        *)
(*        firmware >= Ask AMX about support for UDP #3     *)
(*                                                         *)
(*  COMMENTS: Rane VIA10 Netlinx Demo controls the output  *)
(*            Volume controls for the ECB 62, RPM 26v      *)
(*            and RPE 228d using Ethernet.                 *)
(*            Video-Follows-Audio is also supported.       *)
(* Include Files: RaneCon.axi, RaneVar.axi                 *)
(* Library Files: RW232_Q.lib, DoRW232.lib, RaneIni.lib,   *)
(*                Rw232Vols.lib, SR1_Q.lib, DoSR1.lib      *)
(* TouchPane File: Rane Via10,Netlinx Demo1.tpd            *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* System Type : Netlinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
(* Set Netlinx Device address to 1 *)
TP          = 128:1:1    (* AXT-CA10/AXLINK                *)
VIA10_RS232 = 0:2:0 // VIRTUAL DEVICE FOR UDP
VIA10_HOST  = 0:3:0 // VIRTUAL DEVICE FOR UDP

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
(* RANE *)
// IP address of the remote Netlinx Master Rane Via10.
VIA10_IP   = '192.168.48.216'
(* RW 232 Device Addresses *)
RPE228_ADDRESS = 2
RPM26_ADDRESS  = 3
ECB62_ADDRESS  = 4
ECM64_ADDRESS  = 5

(* !!!!! Don't include (INCLUDE_<UNIT>) if not used -
         Comment out or remove (INCLUDE_<UNIT>) !!!!! *)

INCLUDE_VIA10         = 1   (* This Program uses VIA10 *)
INCLUDE_RW232         = 1   (* This Program uses RW232 *)
INCLUDE_ECB62         = 1   (* This Program uses the ECB 62 *)
INCLUDE_ECM64         = 1   (* This Program uses the ECM 64 *)
INCLUDE_RPM26         = 1   (* This Program uses an RPM 26V *)
INCLUDE_RPE228        = 1   (* This Program uses an RPE 228d *)
INCLUDE_OPSTATS       = 1   (* This Program uses Opstats *)
INCLUDE_ECB62_OPSTATS = 1   (* This Program uses ECB 62 OPSTATS *)
INCLUDE_ECM64_OPSTATS = 1   (* This Program uses ECM 64 OPSTATS *)

INCLUDE 'RaneCon.axi'   (* Rane Constants - Contains all the SPLs -
                          Must be assigned last *)
(* Button Names *)

ECB_VOL_BAR  = 1
RPM_VOL_BAR  = 2
RPE_VOL_BAR  = 3
ECM_VOL_BAR  = 4
VIA10_ADC1_BAR  = 5

ECB_UP_BTN         = 28
ECB_DWN_BTN        = 29
ECB_MUTE_BTN       = 30
ECB_MEMORY1        = 1
ECB_MEMORY2        = 2
ECB_MEMORY3        = 3

RPM_UP_BTN         = 31
RPM_DWN_BTN        = 32
RPM_MUTE_BTN       = 33
RPM_MEMORY1        = 4
RPM_MEMORY2        = 5
RPM_MEMORY3        = 6

RPE_UP_BTN         = 34
RPE_DWN_BTN        = 35
RPE_MUTE_BTN       = 36
RPE_MEMORY1        = 7
RPE_MEMORY2        = 8
RPE_MEMORY3        = 9

ECM_UP_BTN         = 37
ECM_DWN_BTN        = 38
ECM_PRIV_BTN       = 39
ECM_MEMORY1        = 10
ECM_MEMORY2        = 11
ECM_MEMORY3        = 12

OFF_HOOK_BTN       = 13
HOLD_BTN           = 14
FLASH_BTN          = 15
RING_INDICATOR     = 16
RPE_BOTH_BTN       = 17
RPE_CH1_BTN        = 18
RPE_CH2_BTN        = 19
(* 48-59 Keypad *)
HANGUP_BTN         = 60
DIAL_BTN           = 61
REDIAL_BTN         = 62
AUTO_ANSWER_BTN    = 63
BACKSPACE_BTN      = 64
CLEAR_BTN          = 65
PAUSE_BTN          = 66
//Camera tracking Buttons 70-80
RELAY1_BTN         = 81
RELAY2_BTN         = 82
RELAY3_BTN         = 83
RELAY4_BTN         = 84
RELAY5_BTN         = 85
RELAY6_BTN         = 86
RELAY7_BTN         = 87
RELAY8_BTN         = 88
GET_ADC_BTN        = 89
STOP_OPSTAT_BTN    = 90

SYSTEM_ON_BTN      = 101
SYSTEM_OFF_BTN     = 102

KEY_FONT           = '3'  (* Medium Font *)
(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE
(* RANE *)
INCLUDE 'RaneVar.axi'  (* Rane Variables *)

CHAR DTMFrxNumber

RW232data
SystemOn
NewVolume
ECBvolUp
ECBvolDwn
ECBvolume
OldECBvolume
OldCECBvol
ECMvolUp
ECMvolDwn
ECMvolume
OldECMvolume
OldCECMvol
RPEvolUp
RPEvolDwn
RPEvolume
RPEvolume1
RPEvolume2
SavedRPEvol
OldRPEvolume
OldCRPEvol
RPMvolUp
RPMvolDwn
RPMvolume
OldRPMvolume
OldCRPMvol
StopOpstat
ECB_Memory
OldECB_Memory
MasterPort
OldMasterPort
MasterMic
OldMasterMic
OldMasterMic1
MicSignal
CameraTracking
KeyPadEntry[20]
LastEntry[20]
LastButton
KeyPressed
NewKey
KeyReady
ClearOldNumber
OffHook
SingleKey[20]
ECBmemory
ECMmemory
RPMmemory
RPEmemory
CHAR RPEchannel
Via10ADClevels[8]
Via10Relays[8]
INTEGER nKEYPAD_BTNS[]  = { 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, PAUSE_BTN }
(*DEVCHAN dcKEYPAD_BTNS[] = {
                            (* 0-9 *)
                            { TP, 48 }, { TP, 49}, {TP, 50} , { TP, 51}, { TP, 52},
                            { TP, 53 }, { TP, 54}, {TP, 55} , { TP, 56}, { TP, 57},
                            (* * AND # *)
                            { TP, 58 }, { TP, 59},
                            { TP, PAUSE_BTN }
                          } *)

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
([TP,SYSTEM_ON_BTN],[TP,SYSTEM_OFF_BTN])
([TP,71]..[TP,80])
([TP,ECB_MEMORY1]..[TP,ECB_MEMORY3])
([TP,RPM_MEMORY1]..[TP,RPM_MEMORY3])
([TP,RPE_MEMORY1]..[TP,RPE_MEMORY3])
([TP,ECM_MEMORY1]..[TP,ECM_MEMORY3])
([TP,RPE_BOTH_BTN]..[TP,RPE_CH2_BTN])

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

(* Initializes system by clearing or setting all startup parameters *)
DEFINE_CALL 'DoVia10Relays'
{
// Open port for Tx only
  IP_CLIENT_OPEN(VIA10_HOST.PORT,VIA10_IP,VIA10_HOST_PORT,2)
  SEND_STRING VIA10_HOST, "WriteVia10relays,Via10Relays"
  IP_CLIENT_CLOSE(VIA10_HOST.PORT)
// Open port for Tx and Rx
  WAIT 1
  {
    IP_CLIENT_OPEN(VIA10_HOST.PORT,VIA10_IP,VIA10_HOST_PORT,3)
    SEND_STRING VIA10_HOST, ReadVia10relays
  }
}

(***************** Clear SingleKey ****************)
DEFINE_CALL 'ClearSingleKey'
{
  KeyReady = 0
  SET_LENGTH_STRING (SingleKey,0)
  SEND_COMMAND TP,'TEXT1-|'
}

(***************** Clear Key ****************)
DEFINE_CALL 'ClearKey'
{
  ON[TP,CLEAR_BTN]
  KeyReady = 0
  SET_LENGTH_STRING (KeyPadEntry,0)
  SET_LENGTH_STRING (LastEntry,0)
  SET_LENGTH_STRING (SingleKey,0)
  SEND_COMMAND TP,'TEXT1-|'
  ClearOldNumber = 0
}

(* Initializes the Via 10 *)
DEFINE_CALL 'IniVia10'
{
//IP_Client_Open(LocalPort, ServerAddress, ServerPort, Protocol)
// Open port for Tx only
  IP_CLIENT_OPEN(VIA10_RS232.PORT,VIA10_IP,VIA10_RS232_PORT,2)
// ID = 00,00 - Cmd = 00,10 - Flags = 00,03 - Len = 00,02 - Baud = 05(19.2), Parity = 01(Even)
  SEND_STRING VIA10_RS232, SetVia10rw232
  IP_CLIENT_CLOSE(VIA10_RS232.PORT)
// Open port for Tx and Rx
  IP_CLIENT_OPEN(VIA10_HOST.PORT,VIA10_IP,VIA10_HOST_PORT,3)
  SEND_STRING VIA10_HOST, ReadVia10relays
}

(* Initializes system by clearing or setting all startup parameters *)
DEFINE_CALL 'ClearSystem'
{
  RaneInfo = "" (* Use this variable for system debug *)
  SYSTEM_CALL 'RaneIni'
  (* Used to clear the level control *)
  SYSTEM_CALL 'Rw232Vols'(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255)
  CALL 'ClearKey'
  OldECB_Memory = $ff
  OldMasterPort = $ff
  OldMasterMic1 = $ff
  MicSignal = 0
  CameraTracking = 0
  ECBmemory = 0
  ECMmemory = 0
  RPMmemory = 0
  RPEmemory = 0
  RPEchannel = 0
  CANCEL_WAIT 'GO_HOME'
  ON [TP,80] // Camera Tracking Off
  ON [TP,RPE_BOTH_BTN]
  OFF [TP,AUTO_ANSWER_BTN]
  OFF [TP,OFF_HOOK_BTN]
  OFF [TP,RING_INDICATOR]
  OFF [TP,HOLD_BTN]
  ON [TP,ECB_MEMORY1]
  OFF [TP,ECB_MEMORY2]
  OFF [TP,ECB_MEMORY3]
  ON [TP,RPM_MEMORY1]
  OFF [TP,RPM_MEMORY2]
  OFF [TP,RPM_MEMORY3]
  ON [TP,RPE_MEMORY1]
  OFF [TP,RPE_MEMORY3]
  ON [TP,ECM_MEMORY1]
  OFF [TP,ECM_MEMORY2]
  OFF [TP,ECM_MEMORY3]
  OFF [TP,GET_ADC_BTN]
}

(*********** System Start ****************)
(* Initializes system by clearing or setting all startup parameters,
   recalling memory 1 port and mic settings for ECB, memory 1 for the RPD 1, *)
DEFINE_CALL 'SystemStart'
{
  ON [TP,SYSTEM_ON_BTN]
  CALL 'ClearSystem'
  CALL 'IniVia10'
  OldMasterMic = 0
  OffHook      = 0
  StopOpstat   = 0
  SystemOn     = 1
  SystemReady  = 1
  OFF [TP,STOP_OPSTAT_BTN]

  (* Recall Memory 1 on all devices *)
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
  SYSTEM_CALL 'RW232_Q' (RW232_ALL_DEVICES, RW232_ALL_DEVICES, RW232_RECALL_MEMORY, ALL_MEMORY, MEMORY1,0,"")

      (* Reset volume level. TP only *)
  (* Since volume is within SystemReady and not in mainline, *)
  (* the TP Level will not jump it must be incremented.  *)

  OldECBvolume = 255 (* Reset Volume *)
  ECBvolume    = 191 (* 10 dB ECB = 255 - ((ECB62 Volume * 256) / 80)  see RW Manual-26 *)
//    RW232data = ((((ECBvolume - 255) BXOR $FFFF) + 1) * 80) / 256

  IF (ECBvolume)
  {
    SEND_LEVEL TP,ECB_VOL_BAR,ECBvolume-1
    SEND_LEVEL TP,ECB_VOL_BAR,ECBvolume
  }

  OldECMvolume = 255 (* Reset Volume *)
  ECMvolume    = 196 (* Reset PGMVolume to -10dB out* = ((ECMlevel-58) * 255)/60 [ECMlevel = 118-4-10 = 104] *)
  IF (ECMvolume)
  {
    SEND_LEVEL TP,ECM_VOL_BAR,ECMvolume-1
    SEND_LEVEL TP,ECM_VOL_BAR,ECMvolume
  }

  OldRPEvolume = 255 (* Reset Volume *)
  RPEvolume    = 128 (* 0 dB  *)
  RPEvolume1   = 128 (* 0 dB  *)
  RPEvolume2   = 128 (* 0 dB  *)
  SavedRPEvol  = 128
  IF (RPEvolume)
  {
    SEND_LEVEL TP,RPE_VOL_BAR,RPEvolume-1
    SEND_LEVEL TP,RPE_VOL_BAR,RPEvolume
  }

  OldRPMvolume = 255 (* Reset Volume *)
  RPMvolume    = 210 (* -10 dB *)

  IF (RPMvolume)
  {
    SEND_LEVEL TP,RPM_VOL_BAR,RPMvolume-1
    SEND_LEVEL TP,RPM_VOL_BAR,RPMvolume
  }
}

(*********** System Off ****************)
DEFINE_CALL 'SystemOff'
{
  StopOpstat = 1
  ON [TP,STOP_OPSTAT_BTN]
  ON [TP,SYSTEM_OFF_BTN]
  SEND_COMMAND TP,"'@PPA'"  // Clear all Popups
  (* Recall Memory 1 on all devices *)
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
  SYSTEM_CALL 'RW232_Q' (RW232_ALL_DEVICES, RW232_ALL_DEVICES, RW232_RECALL_MEMORY, ALL_MEMORY, MEMORY1,0,"")
  SystemReady = 0
  WAIT 10
  {
    CALL 'ClearSystem'
    SystemReady = 0
    SystemOn = 0
  }
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

SEND_COMMAND TP,"'WAKE'"
SEND_COMMAND TP,"'PAGE-Main Page'"
CALL 'ClearSystem'
CALL 'IniVia10'
SystemOn = 1
SystemReady = 1
CALL 'SystemOff'

(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT[VIA10_RS232]
{
  STRING:
  {
    IF (DATA.TEXT[8]) // Get Length byte 8 using Via10 Data Packet
       RW232rxBuffer = "RW232rxBuffer,MID_STRING(DATA.TEXT,9,DATA.TEXT[8])"
  }
}

DATA_EVENT[VIA10_HOST]
{
  STRING:
  {
    IF (DATA.TEXT[6] = 1 && DATA.TEXT[10]) // Test for Via10 Packet for Relays
    {
       Via10Relays = "MID_STRING(DATA.TEXT,11,DATA.TEXT[10])"
       [TP,RELAY1_BTN] = Via10Relays[1]
       [TP,RELAY2_BTN] = Via10Relays[2]
       [TP,RELAY3_BTN] = Via10Relays[3]
       [TP,RELAY4_BTN] = Via10Relays[4]
       [TP,RELAY5_BTN] = Via10Relays[5]
       [TP,RELAY6_BTN] = Via10Relays[6]
       [TP,RELAY7_BTN] = Via10Relays[7]
       [TP,RELAY8_BTN] = Via10Relays[8]
    }
    IF (DATA.TEXT[6] = 2 && DATA.TEXT[10]) // Test for Via10 Packet for ADCs
    {
      Via10ADClevels = "MID_STRING(DATA.TEXT,11,DATA.TEXT[10])"
      SEND_LEVEL TP,VIA10_ADC1_BAR,Via10ADClevels[1]
    }
    IP_CLIENT_CLOSE(VIA10_HOST.PORT)
  }
}

//System Power
BUTTON_EVENT[TP,SYSTEM_ON_BTN]
{
  PUSH:
  {
    CALL 'SystemStart'
  }
}
//System Off
BUTTON_EVENT[TP,SYSTEM_OFF_BTN]
{
  PUSH:
  {
    CALL 'SystemOff'
  }
}

BUTTON_EVENT[TP,GET_ADC_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      [TP,GET_ADC_BTN] = ![TP,GET_ADC_BTN]
    }
  }
}

BUTTON_EVENT[TP,RELAY1_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY1_BTN])
      {
        OFF [TP,RELAY1_BTN]
        Via10Relays[1] = 0
      }
      ELSE
      {
        ON [TP,RELAY1_BTN]
        Via10Relays[1] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RELAY2_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY2_BTN])
      {
        OFF [TP,RELAY2_BTN]
        Via10Relays[2] = 0
      }
      ELSE
      {
        ON [TP,RELAY2_BTN]
        Via10Relays[2] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RELAY3_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY3_BTN])
      {
        OFF [TP,RELAY3_BTN]
        Via10Relays[3] = 0
      }
      ELSE
      {
        ON [TP,RELAY3_BTN]
        Via10Relays[3] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RELAY4_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY4_BTN])
      {
        OFF [TP,RELAY4_BTN]
        Via10Relays[4] = 0
      }
      ELSE
      {
        ON [TP,RELAY4_BTN]
        Via10Relays[4] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RELAY5_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY5_BTN])
      {
        OFF [TP,RELAY5_BTN]
        Via10Relays[5] = 0
      }
      ELSE
      {
        ON [TP,RELAY5_BTN]
        Via10Relays[5] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RELAY6_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY6_BTN])
      {
        OFF [TP,RELAY6_BTN]
        Via10Relays[6] = 0
      }
      ELSE
      {
        ON [TP,RELAY6_BTN]
        Via10Relays[6] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RELAY7_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY7_BTN])
      {
        OFF [TP,RELAY7_BTN]
        Via10Relays[7] = 0
      }
      ELSE
      {
        ON [TP,RELAY7_BTN]
        Via10Relays[7] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RELAY8_BTN]
{
  PUSH:
  {
    IF (SystemOn)
    {
      IF ([TP,RELAY8_BTN])
      {
        OFF [TP,RELAY8_BTN]
        Via10Relays[8] = 0
      }
      ELSE
      {
        ON [TP,RELAY8_BTN]
        Via10Relays[8] = 1
      }
      CALL 'DoVia10Relays'
    }
  }
}

BUTTON_EVENT[TP,RPE_BOTH_BTN]
{
  PUSH:
  {
    ON[TP,RPE_BOTH_BTN]
    IF (RPEchannel = 1)
      RPEvolume1 = RPEvolume
    IF (RPEchannel = 2)
      RPEvolume2 = RPEvolume
    RPEchannel = 0
    RPEvolume = SavedRPEvol
  }
}

BUTTON_EVENT[TP,RPE_CH1_BTN]
{
  PUSH:
  {
    ON[TP,RPE_CH1_BTN]
    IF (RPEchannel = 0)
      SavedRPEvol = RPEvolume
    IF (RPEchannel = 2)
      RPEvolume2 = RPEvolume
    RPEvolume = RPEvolume1
    RPEchannel = 1

  }
}

BUTTON_EVENT[TP,RPE_CH2_BTN]
{
  PUSH:
  {
    ON[TP,RPE_CH2_BTN]
    IF (RPEchannel = 0)
      SavedRPEvol = RPEvolume
    IF (RPEchannel = 1)
      RPEvolume1 = RPEvolume
    RPEvolume = RPEvolume2
    RPEchannel = 2
  }
}

BUTTON_EVENT[TP,ECB_MEMORY1]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,ECB_MEMORY1]
      ECBmemory = ECB_MEMORY1
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_RECALL_MEMORY, ALL_MEMORY, MEMORY1, 0, "")
    }
  }
}

// Memory 2 Port settings only
BUTTON_EVENT[TP,ECB_MEMORY2]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,ECB_MEMORY2]
      ECBmemory = ECB_MEMORY2
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_RECALL_MEMORY, PORT_SETTINGS, MEMORY2, 0, "")
    }
  }
}

// Memory 3 Mic settings only
BUTTON_EVENT[TP,ECB_MEMORY3]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,ECB_MEMORY3]
      ECBmemory = ECB_MEMORY3
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_RECALL_MEMORY, MIC_SETTINGS, MEMORY2, 0, "")
    }
  }
}

BUTTON_EVENT[TP,RPM_MEMORY1]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,RPM_MEMORY1]
      RPMmemory = RPM_MEMORY1
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (RPM_26, RPM26_ADDRESS, RW232_RECALL_MEMORY, ALL_MEMORY, MEMORY1, 0, "")
    }
  }
}

BUTTON_EVENT[TP,RPM_MEMORY2]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,RPM_MEMORY2]
      RPMmemory = RPM_MEMORY2
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (RPM_26, RPM26_ADDRESS, RW232_RECALL_MEMORY, ALL_MEMORY, MEMORY2, 0, "")
    }
  }
}

BUTTON_EVENT[TP,RPM_MEMORY3]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,RPM_MEMORY3]
      RPMmemory = RPM_MEMORY3
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (RPM_26, RPM26_ADDRESS, RW232_RECALL_MEMORY, ALL_MEMORY, MEMORY3, 0, "")
    }
  }
}

BUTTON_EVENT[TP,RPE_MEMORY1]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,RPE_MEMORY1]
      RPEmemory = RPE_MEMORY1
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (RPE_228, RPE228_ADDRESS, RW232_RECALL_MEMORY, RPEchannel, MEMORY1, 0, "")
    }
  }
}

BUTTON_EVENT[TP,RPE_MEMORY2]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,RPE_MEMORY2]
      RPEmemory = RPE_MEMORY2
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (RPE_228, RPE228_ADDRESS, RW232_RECALL_MEMORY, RPEchannel, MEMORY2, 0, "")
    }
  }
}

BUTTON_EVENT[TP,RPE_MEMORY3]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,RPE_MEMORY3]
      RPEmemory = RPE_MEMORY3
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (RPE_228, RPE228_ADDRESS, RW232_RECALL_MEMORY, RPEchannel, MEMORY3, 0, "")
    }
  }
}

BUTTON_EVENT[TP,ECM_MEMORY1]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,ECM_MEMORY1]
      ECMmemory = ECM_MEMORY1
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_RECALL_MEMORY, ALL_MEMORY, MEMORY1, 0, "")
    }
  }
}

BUTTON_EVENT[TP,ECM_MEMORY2]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,ECM_MEMORY2]
      ECMmemory = ECM_MEMORY1
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_RECALL_MEMORY, INPUT_SETTINGS, MEMORY2, 0, "")
    }
  }
}

BUTTON_EVENT[TP,ECM_MEMORY3]
{
  PUSH:
  {
    IF (SystemReady)
    {
      ON[TP,ECM_MEMORY3]
      ECMmemory = ECM_MEMORY3
                (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_RECALL_MEMORY, OUTPUT_SETTINGS, MEMORY2, 0, "")
    }
  }
}

// Privacy control for ECM
BUTTON_EVENT[TP,ECM_PRIV_BTN]
{
  PUSH:
  {
    IF (SystemReady)
    {
      IF (![TP,ECM_PRIV_BTN])
      {
        ON[TP,ECM_PRIV_BTN]  (* PRIVACY *)
        RW232data = 1
      }
      ELSE
      {
        OFF[TP,ECM_PRIV_BTN]
        RW232data = 0
      }
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_DATA, 0, 0, ECM64_PRIVACY, "RW232data")
    }
  }
}

// Camera Tracking
BUTTON_EVENT[TP,71]
{
  PUSH:  // Mic 1 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 121, "1")
  }
  RELEASE:  // Mic 1 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 121, "2")
  }
}

BUTTON_EVENT[TP,72]
{
  PUSH:  // Mic 2 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 128, "1")
  }
  RELEASE:  // Mic 2 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 128, "2")
  }
}

BUTTON_EVENT[TP,73]
{
  PUSH:  // Mic 3 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 135, "1")
  }
  RELEASE:  // Mic 3 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 135, "2")
  }
}

BUTTON_EVENT[TP,74]
{
  PUSH:  // Mic 4 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 142, "1")
  }
  RELEASE:  // Mic 4 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 142, "2")
  }
}

BUTTON_EVENT[TP,75]
{
  PUSH:  // Mic 5 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 149, "1")
  }
  RELEASE:  // Mic 5 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 149, "2")
  }
}

BUTTON_EVENT[TP,76]
{
  PUSH:  // Mic 6 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 156, "1")
  }
  RELEASE:  // Mic 6 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 156, "2")
  }
}

BUTTON_EVENT[TP,77]
{
  PUSH:  // Mic 7 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 163, "1")
  }
  RELEASE:  // Mic 7 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 163, "2")
  }
}

BUTTON_EVENT[TP,78]
{
  PUSH:  // Mic 8 Signal Mode - Force On
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 170, "1")
  }
  RELEASE:  // Mic 8 Signal Mode - Automatic
  {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
    SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_SEND_DATA, 0, 0, 170, "2")
  }
}

BUTTON_EVENT[TP,80]
{
  PUSH:
  {
    IF (SystemReady)
    {
      IF (!CameraTracking)
      {
        CameraTracking = 1
        ON[TP,79] // Recall preset Home
      }
      ELSE
      {
        CameraTracking = 0
        ON[TP,80]
      }
    }
  }
}

(******************************  ECM PAGE ***********************************)
BUTTON_EVENT[TP,CLEAR_BTN]
{
  PUSH:
  {
    CALL 'ClearKey'
  }
}

BUTTON_EVENT[TP,REDIAL_BTN]
{
  PUSH:
  {
    IF (SystemReady && (!OffHook))
    {
      PULSE[TP,REDIAL_BTN]
      KeyPadEntry = LastEntry
      IF (LENGTH_STRING (KeyPadEntry))
      {
        NewKey = 1
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
                  (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = number, NULL *)
       SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_DIAL_CMD, 0, 0, "KeyPadEntry,0")
      }
    }
  }
}

BUTTON_EVENT[TP,HOLD_BTN]
{
  PUSH:
  {
    IF (SystemReady && OffHook)
    {
      IF ([TP,HOLD_BTN])
      {
        OFF [TP,HOLD_BTN]
                  (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = number, NULL *)
        SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_DIAL_CMD, 0, 0, "'!4',0")
      }
      ELSE
      {
        ON [TP,HOLD_BTN]
                  (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = number, NULL *)
        SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_DIAL_CMD, 0, 0, "'!3',0")
      }
    }
  }
}

BUTTON_EVENT[TP,DIAL_BTN]
{
  PUSH:
  {
    IF (SystemReady && (!OffHook))
    {
      PULSE [TP,DIAL_BTN]
      IF (KeyReady)  // Dial number
      {
        ON [TP,OFF_HOOK_BTN]
        KeyReady = 0
        LastEntry = KeyPadEntry
                    (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = number, NULL *)
        SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_DIAL_CMD, 0, 0, "KeyPadEntry,0")
        ClearOldNumber = 1 //Start with new number if a key number is pressed
      }
      ELSE  //Just go Off Hook
      {
        ON [TP,OFF_HOOK_BTN]
                    (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = Off Hook *)
        SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_OFF_HOOK_CMD, 0, 0, "1")
      }
    }
  }
}

BUTTON_EVENT[TP,OFF_HOOK_BTN]
{
  PUSH:
  {
    IF (SystemReady)
    {
      IF (![TP,OFF_HOOK_BTN])
      {
        ON [TP,OFF_HOOK_BTN]
        RW232data = 1
      }
      ELSE
      {
        OFF [TP,OFF_HOOK_BTN]  // Go On Hook
        RW232data = 0
        CALL 'ClearSingleKey'
      }
      KeyReady = 0
                    (* Device Type, Device Address, Command, Hybrid Command, 0, 0, Data = Off Hook *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_OFF_HOOK_CMD, 0, 0, "RW232data")
    }
  }
}

BUTTON_EVENT[TP,FLASH_BTN] // See Keypad entry for pause
{
  PUSH:
  {
    IF (SystemReady && (OffHook))
    {
      PULSE [TP,FLASH_BTN]
                    (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = number, NULL *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_DIAL_CMD, 0, 0, "'!1',0")
    }
  }
}

BUTTON_EVENT[TP,HANGUP_BTN]
{
  PUSH:
  {
    IF (SystemReady)
    {
      PULSE [TP,HANGUP_BTN]
      CALL 'ClearSingleKey'
      OFF [TP,OFF_HOOK_BTN]
                    (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = Off Hook *)
       SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_OFF_HOOK_CMD, 0, 0, "0")
     }
  }
}

BUTTON_EVENT[TP,AUTO_ANSWER_BTN]
{
  PUSH:
  {
    IF (SystemReady)
    {
      IF (![TP,AUTO_ANSWER_BTN])
      {
        ON [TP,AUTO_ANSWER_BTN]
        RW232data = 2        (* ANSWER on 2nd Ring *)
      }
      ELSE
      {
        OFF [TP,AUTO_ANSWER_BTN]
        RW232data = 0        (* Auto ANSWER off *)
      }
                    (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_DATA, 0, 0, ECM64_AA_RING_COUNT, "RW232data")
    }
  }
}

BUTTON_EVENT[TP,BACKSPACE_BTN]
{
  PUSH:
  {
    IF ((!OffHook) && LENGTH_STRING(KeyPadEntry))
    {
      SET_LENGTH_STRING (KeyPadEntry, LENGTH_STRING(KeyPadEntry)-1)
      SEND_COMMAND TP,"'!T',1,KeyPadEntry"
      NewKey = 1
    }
  }
}

BUTTON_EVENT[TP,STOP_OPSTAT_BTN]
{
  PUSH:
  {
    StopOpstat = !StopOpstat
    [TP,STOP_OPSTAT_BTN] = StopOpstat
  }
}

LEVEL_EVENT[TP,ECB_VOL_BAR]
{
  ECBvolume = LEVEL.VALUE
}

LEVEL_EVENT[TP,ECM_VOL_BAR]
{
  ECMvolume = LEVEL.VALUE
}

LEVEL_EVENT[TP,RPM_VOL_BAR]
{
  RPMvolume = LEVEL.VALUE
}

LEVEL_EVENT[TP,RPE_VOL_BAR]
{
  RPEvolume = LEVEL.VALUE
}

(* keypad *)
//BUTTON_EVENT[dvKEYPAD_BTNS]
BUTTON_EVENT[TP,nKEYPAD_BTNS]
{
  PUSH:
  {
    KeyPressed = GET_LAST(nKEYPAD_BTNS)
    SELECT
    {
      ACTIVE (BUTTON.INPUT.CHANNEL = 0): {}
      ACTIVE (LENGTH_STRING(KeyPadEntry) >= 20): {}
      ACTIVE (!OffHook):
      {
        IF (ClearOldNumber)             // Start with new number
          CALL 'ClearKey'
        SWITCH (KeyPressed)
        {
          CASE 11:
            KeyPadEntry = "KeyPadEntry,'*'"
          CASE 12:
            KeyPadEntry = "KeyPadEntry,'#'"
          CASE 13:
            KeyPadEntry = "KeyPadEntry,','"
          DEFAULT:
            KeyPadEntry = "KeyPadEntry, KeyPressed + $2F"
        }
        NewKey = 1
      }
      ACTIVE (1):  // If in Off Hook allow for single key entry without changing last entry
      {
        SWITCH (KeyPressed)
        {
          CASE 11:
            SingleKey = "SingleKey,'*'"
          CASE 12:
            SingleKey = "SingleKey,'#'"
          CASE 13:
            SingleKey = "SingleKey,','"
          DEFAULT:
            SingleKey = "SingleKey,KeyPressed + $2F"
        }
        SEND_COMMAND TP,"'!F',1,KEY_FONT"
        SEND_COMMAND TP,"'!T',1,SingleKey"
                   (* Device Type, Device Address, Command, Hybrid Command, 0,0, Data = number, NULL *)
        SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_SEND_HYBRID_CMD, ECM64_DIAL_CMD, 0, 0, "SingleKey[Length_String(SingleKey)],0")
      }
    }
  }
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

IF (SystemOn && SystemReady)
{

  ON [TP,ECBmemory]
  ON [TP,ECMmemory]
  ON [TP,RPMmemory]
  ON [TP,RPEmemory]


(**************** Get OPSTATs ************************)
// To run RaneWare set StopOpstat = 1 using Debug or assign to a button
  IF (!StopOpstat)
  {
    WAIT 5    (* 500 ms *)
    {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECB_62, ECB62_ADDRESS, RW232_GET_OPSTAT, 0, 0, 0, "")
    }

    WAIT 10  (* 1 Sec *)
    {
                  (* Device Type, Device Address, Command, Channel, Memory, Starting SPL, "Data" *)
      SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_GET_OPSTAT, 0, 0, 0, "")
    }
  }

(**************** ECB OPSTAT ************************)

  (* The following uses the Opstat message *)
  (* and can be used for video follows Mic audio *)

  IF (ECB62opstatReady)
  {
    ECB62opstatReady = 0
    ECB_Memory = RW232myData[2]
    MasterPort = RW232myData[7] + 1
    MasterMic  = RW232myData[8] + 1
    IF (RW232myData[10])  // Use MicSignal to determine if someone is talking
    {
      IF (OldMasterMic) // Someone is already talking
        MicSignal = 1
      ELSE
        WAIT 6 'TALKING'  // Add delay to slow down the switch from wide to talker
          MicSignal = 1 // Use MicSignal to determine if someone is talking
                        // and switch to Master Mic
    }
    ELSE
    {
      MicSignal = 0
      CANCEL_WAIT 'TALKING'
    }

    IF (ECB_Memory <> OldECB_Memory)
    {
      OldECB_Memory = ECB_Memory
      SEND_COMMAND TP,"'!F',2,KEY_FONT"
      SEND_COMMAND TP,"'!T',2,ITOA(ECB_Memory)"
    }

    IF (MasterPort <> OldMasterPort)
    {
      OldMasterPort = MasterPort
      SEND_COMMAND TP,"'!F',3,KEY_FONT"
      SEND_COMMAND TP,"'!T',3,ITOA(MasterPort)"
    }

    IF (MasterMic <> OldMasterMic1)
    {
      OldMasterMic1 = MasterMic
      SEND_COMMAND TP,"'!F',4,KEY_FONT"
      SEND_COMMAND TP,"'!T',4,ITOA(MasterMic)"
    }
  }

  IF (CameraTracking)
  {
    IF (MicSignal)
    {
// switch camera to talkers position
      IF (MasterMic <> OldMasterMic)
      {
        OldMasterMic = MasterMic  // Mic 1 = 0
        CANCEL_WAIT 'GO_HOME'
        SWITCH (MasterMic)
        {
          CASE 1:
          {
            ON[TP,71]
          }
          CASE 2:
          {
            ON[TP,72]
          }
          CASE 3:
          {
            ON[TP,73]
          }
          CASE 4:
          {
            ON[TP,74]
          }
          CASE 5:
          {
            ON[TP,75]
          }
          CASE 6:
          {
            ON[TP,76]
          }
          CASE 7:
          {
            ON[TP,77]
          }
          CASE 8:
          {
            ON[TP,78]
          }
        }
      }
    }
    ELSE
    {
      IF (OldMasterMic)
      {
  // Send camera to home position when there is no audio for 5 seconds
        WAIT 50 'GO_HOME'
        {
          ON[TP,79] // Recall preset Home
          OldMasterMic = 0
        }
      }
    }
  }

(* Example of how to get data from unit
  Get volume level data from rane - start at spl 21 and get 14 bytes
 SYSTEM_CALL 'RW232_Q' (ECM_64, ECM64_ADDRESS, RW232_GET_DATA, 0, 0, 21, "14")
 IF (RW232dataReady = ECM64_ADDRESS)
 {
   RW232dataReady = 0
   [TP,MIC1_MUTE_BTN] = RW232myData[1]
   [TP,MIC2_MUTE_BTN] = RW232myData[2]
   [TP,MIC3_MUTE_BTN] = RW232myData[3]
   [TP,MIC4_MUTE_BTN] = RW232myData[4]

   OldCMic1Vol = RW232myData[7]
   Mic1Volume = (OldCMic1Vol * 255)/31
   OldMic1Volume = Mic1Volume

   OldCMic2Vol = RW232myData[8]
   Mic2Volume = (OldCMic2Vol * 255)/31
   OldMic2Volume = Mic2Volume

   OldCMic3Vol = RW232myData[8]
   Mic3Volume = (OldCMic3Vol * 255)/31
   OldMic3Volume = Mic3Volume

   OldCMic4Vol = RW232myData[10]
   Mic4Volume = (OldCMic4Vol * 255)/31
   OldMic4Volume = Mic4Volume

   SEND_LEVEL TP,MIC1_VOL_BAR,Mic1Volume-1
   SEND_LEVEL TP,MIC1_VOL_BAR,Mic1Volume
   SEND_LEVEL TP,MIC2_VOL_BAR,Mic2Volume-1
   SEND_LEVEL TP,MIC2_VOL_BAR,Mic2Volume
   SEND_LEVEL TP,MIC3_VOL_BAR,Mic3Volume-1
   SEND_LEVEL TP,MIC3_VOL_BAR,Mic3Volume
   SEND_LEVEL TP,MIC4_VOL_BAR,Mic4Volume-1
   SEND_LEVEL TP,MIC4_VOL_BAR,Mic4Volume

   [TP,PGM_MUTE_BTN] = RW232myData[13]
   OldCPgmVol = RW232myData[14]
   IF (OldCPgmvol > 58)
     PgmVolume = (255*(OldCPgmVol - 58)) / 60
   ELSE
     PgmVolume = 0
   OldPgmVolume = PgmVolume

   (* Force Change in Level for display *)
   SEND_LEVEL TP,PGM_VOL_BAR,PgmVolume-1
   SEND_LEVEL TP,PGM_VOL_BAR,PgmVolume
 }
*)
(**************** ECM OPSTAT ************************)

  IF (ECM64opstatReady)
  {
    ECM64opstatReady = 0
    OffHook = RW232myData[7]
    [TP,OFF_HOOK_BTN] = OffHook

    (* Axcess bug - Beware this does not work IF (!OffHook && ECM64opstat[8]) *)
    IF ((!OffHook) && RW232myData[8])
    {
      SEND_COMMAND TP,'ABEEP'
      PULSE [TP,RING_INDICATOR]
      (* The following causes the popup page to activate *)
      SEND_COMMAND TP,"'@PPN-ECM Control'"
    }
    DTMFrxNumber = RW232myData[14]
  }
 (* VOLUME Format *)   (* TP, Up Btn, Dwn Btn, Mute Btn, UnMute Btn, Device Type,
                          Device Address, SPL Index, Volume, OldVolume, OldCalVolume *)
                       (*  Set UnMute to 0 to use Mute as Toggle              *)
(****** ECB 62 Out 1's Volume Control *********)
  NewVolume = 1  // use NewVolume for the Volume #
  SYSTEM_CALL 'Rw232Vols'(TP, ECB_UP_BTN, ECB_DWN_BTN, ECB_MUTE_BTN, 0, ECB_62, ECB62_ADDRESS,
                           ECB62_P1OUT_VOL, ECBvolume, OldECBVolume, OldCECBVol, NewVolume)
  IF (NewVolume)
    SEND_LEVEL TP,ECB_VOL_BAR,ECBvolume

(****** ECM 64 Out 1's Volume Control *********)
  NewVolume = 2
  SYSTEM_CALL 'Rw232Vols'(TP, ECM_UP_BTN, ECM_DWN_BTN, 0, 0, ECM_64, ECM64_ADDRESS,
                           ECM64_OUT1_LEVEL, ECMvolume, OldECMvolume, OldCECMvol, NewVolume)
  IF (NewVolume)
    SEND_LEVEL TP,ECM_VOL_BAR,ECMvolume

(****** RPM 26 Master Out Volume Control *********)
  NewVolume = 3
  SYSTEM_CALL 'Rw232Vols'(TP, RPM_UP_BTN, RPM_DWN_BTN, RPM_MUTE_BTN, 0, RPM_26, RPM26_ADDRESS,
                           RPM_VOL, RPMvolume, OldRPMvolume, OldCRPMvol, NewVolume)
  IF (NewVolume)
  SEND_LEVEL TP,RPM_VOL_BAR,RPMvolume

(****** RPE 228 Out 1 & 2 Volume Control *********)
  NewVolume = 4
  SELECT
  {
    ACTIVE ([TP,RPE_BOTH_BTN]):
      SYSTEM_CALL 'Rw232Vols'(TP, RPE_UP_BTN, RPE_DWN_BTN, RPE_MUTE_BTN, 0, RPE_228, RPE228_ADDRESS,
                               RPE_VOL, RPEvolume, OldRPEvolume, OldCRPEvol, NewVolume)
    ACTIVE ([TP,RPE_CH1_BTN]):
      SYSTEM_CALL 'Rw232Vols'(TP, RPE_UP_BTN, RPE_DWN_BTN, RPE_MUTE_BTN, 0, RPE_228, RPE228_ADDRESS,
                               RPE_VOL1, RPEvolume, OldRPEvolume, OldCRPEvol, NewVolume)
    ACTIVE ([TP,RPE_CH2_BTN]):
      SYSTEM_CALL 'Rw232Vols'(TP, RPE_UP_BTN, RPE_DWN_BTN, RPE_MUTE_BTN, 0, RPE_228, RPE228_ADDRESS,
                               RPE_VOL2, RPEvolume, OldRPEvolume, OldCRPEvol, NewVolume)
  }
  IF (NewVolume)
    SEND_LEVEL TP,RPE_VOL_BAR,RPEvolume

  IF (NewKey)
  {
    NewKey = 0
    KeyReady = 1
    SEND_COMMAND TP,"'!F',1,KEY_FONT"
    SEND_COMMAND TP,"'!T',1,KeyPadEntry"
  }

}  //END SYSTEM READY

IF (SystemOn)
{
// Via10 only (Port#,IP Address, Device Name)
  SYSTEM_CALL 'DoRW232' (VIA10_RS232.PORT,VIA10_IP,VIA10_RS232) // check RW232_Q and empty
  IF ([TP,GET_ADC_BTN])
  {
    WAIT 10
    {
// Open port for Tx and Rx
      IP_CLIENT_OPEN(VIA10_HOST.PORT,VIA10_IP,VIA10_HOST_PORT,3)
      SEND_STRING VIA10_HOST, ReadVia10adc
    }
  }
}

(* DEBUG *)
IF (LENGTH_STRING(RaneInfo))
{
  (* TYPE "MSG ON" AT TERMINAL OR TELNET TO SEE THIS... *)
  SEND_STRING 0,"RaneInfo"
  RaneInfo = ""
}

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

