(* Rane_Con.axi *)
(*   DATE:10/29/01    TIME:13:46:32    *)
(* Rane Corp. 10/29/01 *)
(* RW232, SRM 66, SR 1, RW485, VIA10 Constants *)

ESC = $1B
#IF_NOT_DEFINED VOL_SPEED
  VOL_SPEED = 5
#END_IF

(* Memory Recall Commands *)
  ALL_MEMORY        = 0
  PORT_SETTINGS     = 1
  MIC_SETTINGS      = 2
  MIXER_SETTINGS    = 3
  MIC_MIXER_SETTINGS  = 4
  INPUT_SETTINGS    = 1
  OUTPUT_SETTINGS   = 2
  MEMORY1           = 1
  MEMORY2           = 2
  MEMORY3           = 3
  MEMORY4           = 4
  MEMORY5           = 5
  MEMORY6           = 6
  MEMORY7           = 7
  MEMORY8           = 8
  MEMORY9           = 9
  MEMORY10          = 10
  MEMORY11          = 11
  MEMORY12          = 12
  MEMORY13          = 13
  MEMORY14          = 14
  MEMORY15          = 15
  MEMORY16          = 16

#IF_DEFINED INCLUDE_RW232
  RW232_QLEN           = $FF        (* Size of RW232 Que  *)
  RW232_ALL_DEVICES    = 0
  RW232_GET_OPSTAT     = 0
  RW232_GET_DATA       = 1
  RW232_GET_DTID       = 2
  RW232_GET_GLOBALS    = 3
  RW232_SEND_DATA      = $81
  RW232_RECALL_MEMORY  = $82
  RW232_MUTE_DEVICE    = $87
  RW232_UNMUTE_DEVICE  = $88
  (* RPD 1 *)
  RW232_SEND_MODEM_CMD = $92
  (* End RPD 1 *)
  (* ECM 64 *)
  RW232_SEND_HYBRID_CMD = $92
  (* End RPD 1 *)
  RPE_228   = $00   (* Device Type *)
  RPM_26    = $15
  RPD_1     = $27
  ECB_62    = $30
  ECM_64    = $32
  RW232_NO_ERROR        = 0
  RW232_BAD_DATA        = 1
  RW232_BAD_CODE        = 2
  RW232_DEVICE_LOCED    = 3
  RW232_DEVICE_UNLOCED  = 4
  RW232_MUTED           = 5
  RW232_NOT_MUTED       = 6
  RW232_BAD_CHECKSUM    = 7
  RW232_NOT_CONNECTED   = 8
#END_IF

(* ECS SPL See ECB 62 RW 232 Device Control Language
   Any SPL > 255 must be converted to bytes MSB/LSB
   Only Mic SPLs > Mic 18 are > 255 *)

#IF_DEFINED INCLUDE_ECB62
  ECB62_CHAIRMAN        =  5     (* NEAR SIG OFFSET *)
  ECB62_CHAIRMAN_ON     = 101    (* Chairman Mode On *)
  ECB62_CHAIRMAN_OFF    = 100    (* Chairman Mode Off *)

  ECB62_P1IN_ON_OFF     = 18     (* PORT 1 IN *)
  ECB62_P1_SELECT       = 19     (* PORT 1 INPUT SELECT *)
  ECB62_P1IN_VOL        = 20     (* PORT 1 IN Volume *)
  ECB62_P1OUT_ON_OFF    = 24     (* PORT 1 OUT *)
  ECB62_P1OUT_VOL       = 25     (* PORT 1 OUT Volume *)

  ECB62_P2IN_ON_OFF     = 26     (* PORT 2 IN *)
  ECB62_P2_SELECT       = 27     (* PORT 2 INPUT SELECT *)
  ECB62_P2IN_VOL        = 28     (* PORT 2 IN Volume *)
  ECB62_P2OUT_ON_OFF    = 32     (* PORT 2 OUT *)
  ECB62_P2OUT_VOL       = 33     (* PORT 2 OUT Volume *)

  ECB62_P3IN_ON_OFF     = 34     (* PORT 3 IN *)
  ECB62_P3_SELECT       = 35     (* PORT 3 INPUT SELECT *)
  ECB62_P3IN_VOL        = 36     (* PORT 3 IN Volume *)
  ECB62_P3OUT_ON_OFF    = 40     (* PORT 3 OUT *)
  ECB62_P3OUT_VOL       = 41     (* PORT 3 OUT Volume *)

  ECB62_P4IN_ON_OFF     = 42     (* PORT 4 IN *)
  ECB62_P4_SELECT       = 43     (* PORT 4 INPUT SELECT *)
  ECB62_P4IN_VOL        = 44     (* PORT 4 IN Volume *)
  ECB62_P4OUT_ON_OFF    = 48     (* PORT 4 OUT *)
  ECB62_P4OUT_VOL       = 49     (* PORT 4 OUT Volume *)

  ECB62_P5IN_ON_OFF     = 50     (* PORT 5 IN *)
  ECB62_P5_SELECT       = 51     (* PORT 5 INPUT SELECT *)
  ECB62_P5IN_VOL        = 52     (* PORT 5 IN Volume *)
  ECB62_P5OUT_ON_OFF    = 56     (* PORT 5 OUT *)
  ECB62_P5OUT_VOL       = 57     (* PORT 5 OUT Volume *)

  ECB62_P6IN_ON_OFF     = 58     (* PORT 6 IN *)
  ECB62_P6_SELECT       = 59     (* PORT 6 INPUT SELECT *)
  ECB62_P6IN_VOL        = 60     (* PORT 6 IN Volume *)
  ECB62_P6OUT_ON_OFF    = 64     (* PORT 6 OUT *)
  ECB62_P6OUT_VOL       = 65     (* PORT 6 OUT Volume *)

  ECB62_MIXER1_ON_OFF   = 72
  ECB62_MIXER2_ON_OFF   = 81
  ECB62_MIXER3_ON_OFF   = 90
  ECB62_MIC1_ACTIVE     = 120    (* SET MIC1 TO 0 : MIC#_ACTIVE = MIC#*ECB62_MIC_OFFSET + ECB62_MIC1_ACTIVE *)
  ECB62_MIC_OFFSET      = 7
  ECB62_MIX_OFFSET      = 56
  ECB62_MIC1_MODE       = 121    (* SET MIC1 TO 0 : MIC#_MODE = MIC#*ECB62_MIC_OFFSET + ECB62_MIC1_MODE *)
  ECB62_MIC_AUTO        = 2
  ECB62_MIC_ON          = 1       (* Forced On *)
  ECB62_MIC_OFF         = 0       (* Forced OFF *)
#END_IF

#IF_DEFINED INCLUDE_ECM64
  ECM64_AA_RING_COUNT   = 1
  ECM64_AUTO_DISCONNECT = 2
  ECM64_PRIVACY         = 3
  ECM64_MUTE            = 4
  ECM64_MIC1_MUTE       = 21
  ECM64_MIC2_MUTE       = 22
  ECM64_MIC3_MUTE       = 23
  ECM64_MIC4_MUTE       = 24
  ECM64_LINE_IN_MUTE    = 25
  ECM64_AUX_IN_MUTE     = 26
  ECM64_MIC1_LEVEL      = 27
  ECM64_MIC2_LEVEL      = 28
  ECM64_MIC3_LEVEL      = 29
  ECM64_MIC4_LEVEL      = 30
  ECM64_LINE_IN_LEVEL   = 31
  ECM64_AUX_IN_LEVEL    = 32
  ECM64_OUT1_MUTE       = 33
  ECM64_OUT1_LEVEL      = 34
  ECM64_OUT1_MIX        = 36
  ECM64_OUT2_MUTE       = 43
  ECM64_OUT2_LEVEL      = 44
  ECM64_OUT2_MIX        = 46
  ECM64_OUT3_MUTE       = 53
  ECM64_OUT3_LEVEL      = 54
  ECM64_OUT3_MIX        = 56
  ECM64_HYBRID_MUTE     = 63
  ECM64_HYBRID_LEVEL    = 64
  ECM64_HYBRID_MIX      = 66
  ECM64_DIAL_CMD        = 0
  ECM64_DIAL_S_NUMBER_CMD   = 1
  ECM64_OFF_HOOK_CMD = 2
#END_IF

#IF_DEFINED INCLUDE_RPD1
  RPD1_ANSWER_MODE     = 2
  RPD1_ANSWER_WHEN     = 3
  RPD1_DIAL_CMD        = 1
  RPD1_ANSWER_CMD      = 2
  RPD1_HANG_UP_CMD     = 3
  RW232_ROUTE_CMD      = 4
  RPD1_AT_CMD          = 5
#END_IF

#IF_DEFINED INCLUDE_RPM26
  RPM_VOL = $15
#END_IF

#IF_DEFINED INCLUDE_RPE228
  RPE_VOL  = 29
  RPE_VOL1 = 30
  RPE_VOL2 = 31
#END_IF

(* SR1 Commands *)

#IF_DEFINED INCLUDE_SR1
  SR1_CMD_QUERY         = 0
  SR1_CMD_SUGGEST       = 1
  SR1_CMD_FORCE         = 2
  SR1_CMD_MEMORY        = 3
  SR1_CMD_LEVEL         = 7   (* Replaced with SR1_CMD_FORCE during tx *)
  SR1_QLEN              = $80
#END_IF

#IF_DEFINED INCLUDE_SRM66
  SRM_MY_ADDRESS        = $FC
  SRM_QLEN              = $FF
  SRM_REQ_GROUP_LEN     = 6
  SRM_REQ_OPS_LEN       = 8
(* SRM Commands *)
(*  SRM_REQ_MEM           = 1 *)
  SRM_SEND_MEM          = 2
  SRM_REQ_PARAM         = 3
  SRM_SEND_PARAM        = 4
  SRM_RECALL_MEM        = 5
  SRM_REQ_GROUP_LEVELS  = 6
  SRM_SEND_GROUP_LEVELS = 7
  SRM_REQ_OPS           = 8
  SRM_REQ_REV           = 10
  SRM_PARAM_LEN         = 64
  (* SPL INDEX *)
  SRM_MIX_IN1_LEVEL     = 0
  SRM_MIX_IN2_LEVEL     = 1
  SRM_MIX_IN3_LEVEL     = 2
  SRM_MIX_IN4_LEVEL     = 3
  SRM_MIX_IN5_LEVEL     = 4
  SRM_MIX_IN6_LEVEL     = 5
  SRM_MIX_MASTER_LEVEL  = 6
  SRM_OUT1_GROUP        = 48
  SRM_OUT2_GROUP        = 49
  SRM_OUT3_GROUP        = 50
  SRM_OUT4_GROUP        = 51
  SRM_OUT5_GROUP        = 52
  SRM_OUT6_GROUP        = 53
  SRM_RMT1_GROUP        = 56
  SRM_RMT2_GROUP        = 57
  SRM_RMT3_GROUP        = 58
  SRM_RMT4_GROUP        = 59
  SRM_RMT5_GROUP        = 60
  SRM_RMT6_GROUP        = 61
  SRM_RMT7_GROUP        = 62
  SRM_MASTER_MAP        = 63
  SRM_GROUP1            = 0
  SRM_GROUP2            = 1
  SRM_GROUP3            = 2
  SRM_GROUP4            = 3
  SRM_GROUP5            = 4
  SRM_GROUP6            = 5
#END_IF
(* Always place a CR at the EOF *)

#IF_DEFINED INCLUDE_RW485
#IF_DEFINED __NETLINX__
  RW485_QLEN           = $200        (* Size of RW232 Que  *)
#END_IF
#IF_NOT_DEFINED __NETLINX__
  RW485_QLEN           = $FF        (* Size of RW232 Que  *)
#END_IF
  SR_3                 = $30   (* Device Type *)
#END_IF

#IF_DEFINED INCLUDE_VIA10
  VIA10_HOST_PORT  = $1024 + 111
  VIA10_RS232_PORT = $1024 + 112
  VIA10_RS485_PORT = $1024 + 113
#END_IF
(* EOF *)
