PROGRAM_NAME='RaneVar -   RANEVAR.AXI'
(*   DATE:10/29/01    TIME:13:46:32    *)
(* Rane Corp. 10/29/01 *)
(* Rane_Var.axi *)
(* RW232, SRM66 and SR 1 Variables  *)
(* RW485 and SR 3 Var *)

SystemReady
RaneInfo[50]
BadRaneData

#IF_DEFINED INCLUDE_RW232
  RW232rxBuffer[50]
  RW232myData[50]
  RW232txBuffer[50]
  RW232Buffer[50]
  RW232txQ1[RW232_QLEN]
  RW232txQ2[RW232_QLEN]
  RW232retry
  RW232q1Start
  RW232q1End
  RW232q2Start
  RW232q2End
  RW232q1Len
  RW232q2Len
  OldFB
  RW232timeOut
  RW232retryTimeOut
  SendRW232address
  RW232txOverflow
  RW232RxLen
  Rw232LenRx
  RW232PowerUp
  RW232Step
  GetRW232Data
  RW232dataReady
#IF_NOT_DEFINED __NETLINX__
    RW232rxData  (* Data received by the Get data command *)
    RW232DeviceType
    rxRW232DeviceType
    RW232DeviceAddress
    RW232Command
#END_IF
#IF_DEFINED __NETLINX__
    CHAR RW232rxData  (* Data received by the Get data command *)
    CHAR RW232DeviceType
    CHAR RW232DeviceAddress
    CHAR rxRW232DeviceType
    CHAR RW232Command
#END_IF
#END_IF

(*  DataLen *)
#IF_DEFINED INCLUDE_ECB62_OPSTATS
  ECB62_Opstat
  ECB62opstatReady
#END_IF
#IF_DEFINED INCLUDE_ECM64_OPSTATS
  ECM64_Opstat
  ECM64opstatReady
#END_IF
#IF_DEFINED INCLUDE_RPD1_OPSTATS
  RPD1_Opstat
  RPD1opstatReady
#END_IF

(* SR1 Vars *)
#IF_DEFINED INCLUDE_SR1
  SR1rxBuffer[6]
  SR1txQ[SR1_QLEN]
  SR1txBuffer[6]
  SR1level[7]
  OldSR1level[7]
  SR1Mutes[7]
  SR1txReady
  SR1getMessage
  SR1txOverflow
  SR1qStart
  SR1qEnd
  SR1tx
  SR1active
  StopSR1
  NewSR1Level
  TxNewGlevelToSR1
#END_IF

#IF_DEFINED INCLUDE_SRM66
  SRMrxBuffer[80]
  SRMtxQ[SRM_QLEN]
  SRMtxBuffer[64]
  SRMInputMix1[8]
  SRMInputMix2[8]
  SRMInputMix3[8]
  SRMInputMix4[8]
  SRMInputMix5[8]
  SRMInputMix6[8]
  SRMGroupLevel[8]
  SR1Group[8]
  OutSRMGroup[8]
  SRMLimiters[6]
  SRMmasterMap[1]
  SRMspls[6][7]
  SRMmutes[7]
  SRMgetAddress
  SRMgetMessage
  SRMreqPramReady  (*Request Parameter New Input *)
  SRMgroupReady
  StopSRMrequest
  SRMmemReady
  SRMtxOverflow
#IF_NOT_DEFINED __NETLINX__
    SRMmemory
    SRMmessage
    SRMGroup
    SRMqStart
    SRMqEnd
    SRMqLen
#END_IF
#IF_DEFINED __NETLINX__
    CHAR SRMmemory
    CHAR SRMmessage
    CHAR SRMGroup
    CHAR SRMdirty
    CHAR SRMqStart
    CHAR SRMqEnd
    CHAR SRMqLen
#END_IF
#END_IF

#IF_DEFINED INCLUDE_RW485
  RW485txQ1[RW485_QLEN]
  RW485txQ2[RW485_QLEN]
  RW485rxBuffer[50]
  RW485txBuffer[50]
  RW485Command[10]
  RW485Msg[40]
  RW485retry
  RW485q1Start
  RW485q1End
  RW485q2Start
  RW485q2End
  RW485q1Len
  RW485q2Len
  RW485timeOut
  SendRW485address
  RW485retryTimeOut
  RW485txOverflow
  RW485PowerUp
  GetRW485Data
  RW485dataReady  (* Returns the device address + 1 *)
#IF_NOT_DEFINED __NETLINX__
    RW485DeviceType
    RW485DeviceAddress
#END_IF
#IF_DEFINED __NETLINX__
    CHAR RW485DeviceType
    CHAR RW485DeviceAddress
#END_IF
#END_IF

(* SR3 Vars *)
#IF_DEFINED INCLUDE_SR3
  SR3level[8]
  SR3page[8]
  SR3cmd[8]
  SR3time[8]
  SR3mutes[8]
  NewSR3Page[8]
  UpdateSR3[8]
  SR3lock[8]
  StopSR3
  SR3active
  SR3ready[8]
(*  
  SR3level[1-8]
  SR3level[1] = SR3 address 0 encoder level

  SR3page[1-8]
  SR3page[2] = SR3 address 1 page number

  SR3time[1-8]
  SR3page[3] = SR3 address 2 time in milliseconds knob is pressed in

  NewSR3Page[1-8]
  NewSR3Page[4] = SR3 address 3 page value when knob is released

  SR3cmd[1-8]
  SR3cmd[5] = SR3 address 4 command
  The possible Cmd states:
  0 No Operation The encoder has not changed.
  1 Encoder Left The encoder has been turned counter clockwise.
  2 Encoder Right The encoder has been turned clockwise.
  16 Page Left The encoder has been pushed in and turned counter clockwise.
  32 Page Right The encoder has been pushed in and turned clockwise.
  64 Enter The encoder has been pushed in and released without being turned.

  SR3mutes[1-8] 
  SR3mutes[6] = SR3 address 5 - Used by the RW485vols() to track mute conditions

  UpdateSR3[1-8]
  UpdateSR3[6] = SR3 address 5 - Used by DoSR3() and Rw485Vols() to force level and
                                 page values to the SR3
                                 
  SR3lock[8] = SR3 address 7 - Used to track if the SR3 is locked
  SR3ready[1-8] = Set in DoSR3() when data is set 
*)                                 

#END_IF

#IF_DEFINED INCLUDE_VIA10
  ReadVia10relays[10]
  WriteVia10relays[10]
  SetVia10rw232[10]
  ReadVia10adc[10]
#END_IF

(* Always place a CR at the EOF *)
