PROGRAM_NAME='SRM_DSC - Rane SRM 66 DSC Demo'
(*   DATE:10/11/01    TIME:14:31:54    *)
(* Rane Corp. By: Mike Slattery *)
(* SRM Control Program *)
(* This Demo Program Controls Rane's SRM 66 and SR 1s *)
(* This program now supports block data transfers to the SRM 66 *)
(* See PUSH [TP,LOAD_SRM_BTN] *)

(* Load touchpanel file SRM_DSC.PGZ *)
(* Include files: RaneCon.axi, RaneVar.axi *)
(* Library Files: SRM_Q.lib, SR1_Q.lib, RaneIni.lib, DoSRM.lib,
                  GroupSR1.lib,SrmVols.lib, DoSR1.lib     *)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE
SRM         = 1              (* RANE SRM 9600,N,8,1,485 ENABLE *)
SR1         = 2              (* RANE SR1 9600,N,8,1,485 ENABLE *)
TP          = 128
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

(* Don't include if not used - either comment out or delete *)
INCLUDE_SR1         = 1   (* This Program uses SR 1s *)
INCLUDE_SRM66       = 1   (* This Program uses SRM 66 *)
  (* Must be after the Includes *)
INCLUDE 'RaneCon.axi'   (* Rane Constants *)

(* Button Names *)

(* SRM PAGE *)
VOL_BAR1    = 1
VOL_BAR2    = 2
VOL_BAR3    = 3
VOL_BAR4    = 4
VOL_BAR5    = 5
VOL_BAR6    = 6
VOL_BAR7    = 7
MUTE1_BTN    = 1
MUTE2_BTN    = 2
MUTE3_BTN    = 3
MUTE4_BTN    = 4
MUTE5_BTN    = 5
MUTE6_BTN    = 6
MUTE7_BTN    = 7
MIX1_UP_BTN  = 10
MIX1_DWN_BTN = 11
MIX2_UP_BTN  = 12
MIX2_DWN_BTN = 13
MIX3_UP_BTN  = 14
MIX3_DWN_BTN = 15
MIX4_UP_BTN  = 16
MIX4_DWN_BTN = 17
MIX5_UP_BTN  = 18
MIX5_DWN_BTN = 19
MIX6_UP_BTN  = 20
MIX6_DWN_BTN = 21
MASTER_UP_BTN    = 22
MASTER_DWN_BTN   = 23
RETURN_BTN       = 26
INPUT_MIX_BTN    = 28
CONTROL_BTN      = 29
MIX_SELECT1_BTN  = 31
MIX_SELECT2_BTN  = 32
MIX_SELECT3_BTN  = 33
MIX_SELECT4_BTN  = 34
MIX_SELECT5_BTN  = 35
MIX_SELECT6_BTN  = 36
MIX_SELECT_CLEAR = 37
MEM_SELECT1_BTN  = 41
MEM_SELECT2_BTN  = 42
MEM_SELECT3_BTN  = 43
MEM_SELECT4_BTN  = 44
MEM_SELECT5_BTN  = 45
MEM_SELECT6_BTN  = 46
MEM_SELECT7_BTN  = 47
MEM_SELECT8_BTN  = 48
MEM_SELECT9_BTN  = 49
MEM_SELECT10_BTN = 50
MEM_SELECT11_BTN = 51
MEM_SELECT12_BTN = 52
MEM_SELECT13_BTN = 53
MEM_SELECT14_BTN = 54
MEM_SELECT15_BTN = 55
MEM_SELECT16_BTN = 56
MEM_SELECT17_BTN = 57
MEM_SELECT18_BTN = 58
MEM_SELECT19_BTN = 59
MEM_SELECT20_BTN = 60
MEM_SELECT21_BTN = 61
MEM_SELECT22_BTN = 62
MEM_SELECT23_BTN = 63
MEM_SELECT24_BTN = 64
MEM_CLEAR_BTN    = 65
IN_SELECT1_BTN   = 70
IN_SELECT2_BTN   = 71
IN_SELECT3_BTN   = 72
IN_SELECT4_BTN   = 73
IN_SELECT5_BTN   = 74
IN_SELECT6_BTN   = 75
IN_MASTER_BTN    = 76
IN_SELECT_CLEAR  = 77
OUT_SELECT1_BTN  = 78
OUT_SELECT2_BTN  = 79
OUT_SELECT3_BTN  = 80
OUT_SELECT4_BTN  = 81
OUT_SELECT5_BTN  = 82
OUT_SELECT6_BTN  = 83
OUT_MASTER_BTN   = 84
OUT_SELECT_CLEAR     = 85
SELECT_OUT_GROUP_BTN = 90
SELECT_RMT_GROUP_BTN = 91
SELECT_ROUTE_BTN     = 92
SELECT_ROUTE_CLEAR   = 93
LOAD_SRM_BTN         = 94
MUTE_BTN             = 105
UNMUTE_BTN           = 106
SYSTEM_ON            = 100
SYSTEM_OFF           = 101

SRM_IN_MUTE           = 32
SRM_IN_UNMUTE         = 6  (* 0dB 0 = +6, 32 = MUTE*)
SRM_IN_MASTER         = 35 (* 25-35 = -10dB Where 25 = 0dB*)
SRM_IN_LIMITER        = 28  (* 28 = Max limiter off*)

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

INCLUDE 'RaneVar.axi'  (* Rane Variables *)
Volume1
Volume2
Volume3
Volume4
Volume5
Volume6
Master
OldVolume1
OldVolume2
OldVolume3
OldVolume4
OldVolume5
OldVolume6
OldMaster
OldCalVolume1
OldCalVolume2
OldCalVolume3
OldCalVolume4
OldCalVolume5
OldCalVolume6
OldCalMaster
NewVolume
InSelect
OutSelect
InputSelect
NewGroup
NewOutput
SystemOn
SrmOut
SRMupdate

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       TOGGLING DEFINITIONS GO BELOW                     *)
(***********************************************************)
DEFINE_TOGGLING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE
([TP,MEM_SELECT1_BTN]..[TP,MEM_CLEAR_BTN])
([TP,MIX_SELECT1_BTN]..[TP,MIX_SELECT_CLEAR])
([TP,OUT_SELECT1_BTN]..[TP,OUT_SELECT_CLEAR])
([TP,SELECT_OUT_GROUP_BTN]..[TP,SELECT_ROUTE_CLEAR])
([TP,MUTE_BTN]..[TP,UNMUTE_BTN])
([TP,SYSTEM_ON],[TP,SYSTEM_OFF])

(***********************************************************)
(*           SUBROUTINE DEFINITIONS GO BELOW               *)
(***********************************************************)
DEFINE_CALL 'ClearMutes'
{
  OFF [TP,MUTE1_BTN]
  OFF [TP,MUTE2_BTN]
  OFF [TP,MUTE3_BTN]
  OFF [TP,MUTE4_BTN]
  OFF [TP,MUTE5_BTN]
  OFF [TP,MUTE6_BTN]
  OFF [TP,MUTE7_BTN]
  SRMmutes = "0,0,0,0,0,0,0"
  SR1Mutes = "0,0,0,0,0,0,0"
}

(* Set Levels with data from SRM  *)
DEFINE_CALL 'SetGrpLevels'
{
  IF ([TP,INPUT_MIX_BTN])
  {            (* Level Page *)
    Volume1 = 255 -  ((SRMgroupLevel[1] * 255)/32)
    Volume2 = 255 -  ((SRMgroupLevel[2] * 255)/32)
    Volume3 = 255 -  ((SRMgroupLevel[3] * 255)/32)
    Volume4 = 255 -  ((SRMgroupLevel[4] * 255)/32)
    Volume5 = 255 -  ((SRMgroupLevel[5] * 255)/32)
    Volume6 = 255 -  ((SRMgroupLevel[6] * 255)/32)
    Master =  255 - (((SRMgroupLevel[7] - 25) * 255)/60)
    (* OldMaster = Master *)
    OldCalMaster = (SRMgroupLevel[7] - 25)
    SEND_LEVEL TP,VOL_BAR7,Master
  }
  Else    (* Control Page *)
  {
    Volume1 = 255 -  ((SRMgroupLevel[1] * 255)/30)
    Volume2 = 255 -  ((SRMgroupLevel[2] * 255)/30)
    Volume3 = 255 -  ((SRMgroupLevel[3] * 255)/30)
    Volume4 = 255 -  ((SRMgroupLevel[4] * 255)/30)
    Volume5 = 255 -  ((SRMgroupLevel[5] * 255)/30)
    Volume6 = 255 -  ((SRMgroupLevel[6] * 255)/30)
  }

(*  OldVolume1 = Volume1 *)
  OldCalVolume1 = SRMgroupLevel[1]
  SEND_LEVEL TP,VOL_BAR1,Volume1

(*  OldVolume2 = Volume2 *)
  OldCalVolume2 = SRMgroupLevel[2]
  SEND_LEVEL TP,VOL_BAR2,Volume2

(*  OldVolume3 = Volume3 *)
  OldCalVolume3 = SRMgroupLevel[3]
  SEND_LEVEL TP,VOL_BAR3,Volume3

(*  OldVolume4 = Volume4 *)
  OldCalVolume4 = SRMgroupLevel[4]
  SEND_LEVEL TP,VOL_BAR4,Volume4

(*  OldVolume5 = Volume5 *)
  OldCalVolume5 = SRMgroupLevel[5]
  SEND_LEVEL TP,VOL_BAR5,Volume5

(*  OldVolume6 = Volume6 *)
  OldCalVolume6 = SRMgroupLevel[6]
  SEND_LEVEL TP,VOL_BAR6,Volume6
}


  (* Clear All Inputs On Control Page  *)
DEFINE_CALL 'ClearAllInputs'
{
  OFF [TP,IN_SELECT1_BTN]
  OFF [TP,IN_SELECT2_BTN]
  OFF [TP,IN_SELECT3_BTN]
  OFF [TP,IN_SELECT4_BTN]
  OFF [TP,IN_SELECT5_BTN]
  OFF [TP,IN_SELECT6_BTN]
  OFF [TP,IN_MASTER_BTN]
  InputSelect = 0
}

(* Display Group On Control Page  *)
DEFINE_CALL 'DisplayGroup' (OutGp)
{
  ON [TP,OUT_SELECT_CLEAR]
  SELECT
  {
    ACTIVE (OutGp = 1) :
      ON [TP,OUT_SELECT1_BTN]
    ACTIVE (OutGp = 2) :
      ON [TP,OUT_SELECT2_BTN]
    ACTIVE (OutGp = 3) :
      ON [TP,OUT_SELECT3_BTN]
    ACTIVE (OutGp = 4) :
      ON [TP,OUT_SELECT4_BTN]
    ACTIVE (OutGp = 5) :
      ON [TP,OUT_SELECT5_BTN]
    ACTIVE (OutGp = 6) :
      ON [TP,OUT_SELECT6_BTN]
    ACTIVE (OutGp = 7) :
      ON [TP,OUT_MASTER_BTN]
  }
}

  (* Send New Out Group to Control Group Page  *)
DEFINE_CALL 'SendOutGroup'
{

  SELECT
  {
    ACTIVE (InputSelect = 1) :
    {                      (* Command, Index, Data *)
      OutSRMgroup[1] = NewGroup
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_OUT1_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 2) :
    {                      (* Command, Index, Data *)
      OutSRMgroup[2] = NewGroup
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_OUT2_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 3) :
    {                      (* Command, Index, Data *)
      OutSRMgroup[3] = NewGroup
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_OUT3_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 4) :
    {                      (* Command, Index, Data *)
      OutSRMgroup[4] = NewGroup
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_OUT4_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 5) :
    {                      (* Command, Index, Data *)
      OutSRMgroup[5] = NewGroup
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_OUT5_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 6) :
    {                      (* Command, Index, Data Count, Data *)
      OutSRMgroup[6] = NewGroup
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_OUT6_GROUP,"NewGroup")
    }
  }
  NewOutput = 0
}

#IF_DEFINED INCLUDE_SR1
   (* Send New Remote Group to Control Group Page  *)
DEFINE_CALL 'SendSR1Group'
{
  SELECT
  {
    ACTIVE (InputSelect = 1) :
    {
      SR1Group[1] = NewGroup
      IF (NewGroup)
        SR1level[1] = SRMgroupLevel[NewGroup]
      Else
        SR1level[1] = 100 (* Forces SR1 off *)
      TxNewGlevelToSR1 = 1
                          (* Command, Index, Data *)
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_RMT1_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 2) :
    {
      SR1Group[2] = NewGroup
      IF (NewGroup)
        SR1level[2] = SRMgroupLevel[NewGroup]
      Else
        SR1level[2] = 100
      TxNewGlevelToSR1 = 2
                          (* Command, Index, Data *)
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_RMT2_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 3) :
    {
      SR1Group[3] = NewGroup
      IF (NewGroup)
        SR1level[3] = SRMgroupLevel[NewGroup]
      Else
        SR1level[3] = 100
      TxNewGlevelToSR1 = 4
                          (* Command, Index, Data *)
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_RMT3_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 4) :
    {
      SR1Group[4] = NewGroup
      IF (NewGroup)
        SR1level[4] = SRMgroupLevel[NewGroup]
      Else
        SR1level[4] = 100
      TxNewGlevelToSR1 = 8
                          (* Command, Index, Data *)
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_RMT4_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 5) :
    {
      SR1Group[5] = NewGroup
      IF (NewGroup)
        SR1level[5] = SRMgroupLevel[NewGroup]
      Else
        SR1level[5] = 100
      TxNewGlevelToSR1 = 16
                          (* Command, Index, Data *)
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_RMT5_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 6) :
    {
      SR1Group[6] = NewGroup
      IF (NewGroup)
        SR1level[6] = SRMgroupLevel[NewGroup]
      Else
        SR1level[6] = 100
      TxNewGlevelToSR1 = 32
                          (* Command, Index, Data *)
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_RMT6_GROUP,"NewGroup")
    }
    ACTIVE (InputSelect = 7) :
    {
      SR1Group[7] = NewGroup
      IF (NewGroup)
        SR1level[7] = SRMgroupLevel[NewGroup]
      Else
        SR1level[7] = 100
      TxNewGlevelToSR1 = 64
                          (* Command, Index, Data *)
      SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,SRM_RMT7_GROUP,"NewGroup")
    }
  }
  NewOutput = 0
}
#END_IF

DEFINE_CALL 'UpdateMemory'
{
  ON [TP,OUT_SELECT_CLEAR]
  CALL 'ClearAllInputs'
  SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
  SYSTEM_CALL 'SRM_Q' (SRM_REQ_GROUP_LEVELS,0,"6")
  SYSTEM_CALL 'SRM_Q' (SRM_REQ_OPS,0,"0")
}

(*********** Clear System ****************)
(* Initializes system by clearing or setting all startup parameters *)
DEFINE_CALL 'ClearSystem'
{
  RaneInfo = ""
  (* String Var RaneInfo[] for debug info *)
  SYSTEM_CALL 'RaneIni'
  OFF [TP,MUTE1_BTN]
  OFF [TP,MUTE2_BTN]
  OFF [TP,MUTE3_BTN]
  OFF [TP,MUTE4_BTN]
  OFF [TP,MUTE5_BTN]
  OFF [TP,MUTE6_BTN]
  OFF [TP,MUTE7_BTN]
}

(*********** System Start ****************)
(* Initializes system by clearing or setting all startup parameters,
   recalling memory 1 port and mic settings for ECS, memory 1 for the RPD 1, *)
DEFINE_CALL 'SystemStart'
{
  (* Power-up system *)
  (* ON[RELAY,POWER] *)

  ON [TP,SYSTEM_ON]
  WAIT 10
  {
    CALL 'ClearSystem'
    SystemOn = 1
    SystemReady = 1
                        (* Command, Index, Data *)
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_GROUP_LEVELS,0,"6")
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_OPS,0,"0")
    SRMupdate = 0
    ON [TP,MIX_SELECT1_BTN]
    SrmOut = 1
    WAIT 10
    {
      SRMgroupLevel = LEFT_STRING (SRMInputMix1, 8)
      CALL 'SetGrpLevels'
    }
  }
}

(*********** System Off ****************)
DEFINE_CALL 'SystemOff'
{
  (* Power-Down system *)
  (* OFF[RELAY,POWER] *)

(*  SEND_COMMAND TP,'PAGE-MAIN' *)
  SystemOn = 0
  ON [TP,SYSTEM_OFF]
  CALL 'ClearSystem'
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START
  CREATE_BUFFER SR1, SR1rxBuffer
  CREATE_BUFFER SRM, SRMrxBuffer

  (* Remove comments if using an Axcent 3 *)
  (* SEND_COMMAND SRM, 'SET BAUD 9600,N,8,1,485 ENABLE' *)
  (* SEND_COMMAND SR1, 'SET BAUD 9600,N,8,1,485 ENABLE' *)

  SEND_COMMAND TP,'PAGE-MAIN'

  CREATE_LEVEL TP, VOL_BAR1, Volume1
  CREATE_LEVEL TP, VOL_BAR2, Volume2
  CREATE_LEVEL TP, VOL_BAR3, Volume3
  CREATE_LEVEL TP, VOL_BAR4, Volume4
  CREATE_LEVEL TP, VOL_BAR5, Volume5
  CREATE_LEVEL TP, VOL_BAR6, Volume6
  CREATE_LEVEL TP, VOL_BAR7, Master


  SEND_COMMAND TP,'PAGE-MAIN'
  ON [TP,MIX_SELECT_CLEAR]
  NewVolume = 0
  NewOutput = 0


      (* Clear previous SRMgroupLevel *)
  SEND_LEVEL TP,VOL_BAR1,0
  SEND_LEVEL TP,VOL_BAR2,0
  SEND_LEVEL TP,VOL_BAR3,0
  SEND_LEVEL TP,VOL_BAR4,0
  SEND_LEVEL TP,VOL_BAR5,0
  SEND_LEVEL TP,VOL_BAR6,0
  SEND_LEVEL TP,VOL_BAR7,0

  CALL 'SystemOff'

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

(* System On *)
PUSH [TP,SYSTEM_ON]
  IF (!([TP,SYSTEM_ON]))
    CALL 'SystemStart'

(* System Off *)
PUSH [TP,SYSTEM_OFF]
  CALL 'SystemOff'


IF (SystemReady)
{
(*  IF (StopSRM)
    StopSRM = StopSRM - 1 *)

  IF (PUSH_DEVICE = TP)
  {
    SRMmessage = 255
    StopSRMrequest = 1
  }

  IF (RELEASE_DEVICE = TP)
    StopSRMrequest = 0

  PUSH [TP,INPUT_MIX_BTN]
  {
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    ON [TP,INPUT_MIX_BTN]
    CALL 'ClearMutes'
    ON [TP,MIX_SELECT1_BTN]
    SrmOut = 1
  }

  PUSH [TP,CONTROL_BTN]
  {
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_GROUP_LEVELS,0,"6")
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_OPS,0,"0")
    ON [TP,CONTROL_BTN]
    ON [TP,SELECT_ROUTE_CLEAR]
    CALL 'ClearAllInputs'
    ON [TP,OUT_SELECT_CLEAR]
    InSelect = 0
    OutSelect = 0
    SRMmemReady = 1
    CALL 'ClearMutes'
  }

  PUSH [TP,RETURN_BTN]
  {
    OFF [TP,INPUT_MIX_BTN]
    OFF [TP,CONTROL_BTN]
  }

    (* Level Page *)
  IF ([TP,INPUT_MIX_BTN])
  {
    PUSH [TP,MIX_SELECT1_BTN]
    {
      CALL 'ClearMutes'
      ON [TP,MIX_SELECT1_BTN]
      SrmOut = 1
                          (* Command, Index, Data Count *)
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }

    PUSH [TP,MIX_SELECT2_BTN]
    {
      CALL 'ClearMutes'
      ON [TP,MIX_SELECT2_BTN]
      SrmOut = 2
                          (* Command, Index, Data Count *)
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }

    PUSH [TP,MIX_SELECT3_BTN]
    {
      CALL 'ClearMutes'
      ON [TP,MIX_SELECT3_BTN]
      SrmOut = 3
                          (* Command, Index, Data Count *)
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }

    PUSH [TP,MIX_SELECT4_BTN]
    {
      CALL 'ClearMutes'
      ON [TP,MIX_SELECT4_BTN]
      SrmOut = 4
                          (* Command, Index, Data Count *)
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }

    PUSH [TP,MIX_SELECT5_BTN]
    {
      CALL 'ClearMutes'
      ON [TP,MIX_SELECT5_BTN]
      SrmOut = 5
                          (* Command, Index, Data Count *)
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }

    PUSH [TP,MIX_SELECT6_BTN]
    {
      CALL 'ClearMutes'
      ON [TP,MIX_SELECT6_BTN]
      SrmOut = 6
                        (* Command, Index, Data Count *)
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }

    IF (SRMreqPramReady)
    {
      SRMreqPramReady = 0
      IF ([TP,MIX_SELECT1_BTN])
      {
        SRMgroupLevel = LEFT_STRING (SRMInputMix1, 8)
        CALL 'SetGrpLevels'
      }

      IF ([TP,MIX_SELECT2_BTN])
      {
        SRMgroupLevel = LEFT_STRING (SRMInputMix2, 8)
        CALL 'SetGrpLevels'
      }

      IF ([TP,MIX_SELECT3_BTN])
      {
        SRMgroupLevel = LEFT_STRING (SRMInputMix3, 8)
        CALL 'SetGrpLevels'
      }

      IF ([TP,MIX_SELECT4_BTN])
      {
        SRMgroupLevel = LEFT_STRING (SRMInputMix4, 8)
        CALL 'SetGrpLevels'
      }

      IF ([TP,MIX_SELECT5_BTN])
      {
        SRMgroupLevel = LEFT_STRING (SRMInputMix5, 8)
        CALL 'SetGrpLevels'
      }

      IF ([TP,MIX_SELECT6_BTN])
      {
        SRMgroupLevel = LEFT_STRING (SRMInputMix6, 8)
        CALL 'SetGrpLevels'
      }
    } (* End New form SRM *)
    (* SYSTEM_CALL[N] is not required. Set NewVolume to the volume # you want to control *)
    NewVolume = 1
    (* VOLUME 1 *) (* TP,Up Btn,Dwn Btn,Mute Btn,UnMute Btn,SRM In,SRM Out,Volume,OldVolume,OldCalVolume,Groups,V# *)
                                (* Set UnMute to 0 to use Mute as Toggle *)
    SYSTEM_CALL 'SrmVols'(TP, MIX1_UP_BTN, MIX1_DWN_BTN, MUTE1_BTN, 0, 1, SrmOut,
                              Volume1, OldVolume1, OldCalVolume1, 0, NewVolume)
    IF( NewVolume)
      SEND_LEVEL TP,VOL_BAR1,Volume1

    NewVolume = 2
    (* VOLUME 2 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX2_UP_BTN, MIX2_DWN_BTN, MUTE2_BTN, 0, 2, SrmOut,
                              Volume2, OldVolume2, OldCalVolume2, 0, NewVolume)
    IF( NewVolume)
      SEND_LEVEL TP,VOL_BAR2,Volume2

    NewVolume = 3
    (* VOLUME 3 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX3_UP_BTN, MIX3_DWN_BTN, MUTE3_BTN, 0, 3, SrmOut,
                              Volume3, OldVolume3, OldCalVolume3, 0, NewVolume)
    IF( NewVolume)
      SEND_LEVEL TP,VOL_BAR3,Volume3

    NewVolume = 4
    (* VOLUME 4 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX4_UP_BTN, MIX4_DWN_BTN, MUTE4_BTN, 0, 4, SrmOut,
                              Volume4, OldVolume4, OldCalVolume4, 0, NewVolume)
    IF( NewVolume)
      SEND_LEVEL TP,VOL_BAR4,Volume4

    NewVolume = 5
    (* VOLUME 5 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX5_UP_BTN, MIX5_DWN_BTN, MUTE5_BTN, 0, 5, SrmOut,
                              Volume5, OldVolume5, OldCalVolume5, 0, NewVolume)
    IF( NewVolume)
      SEND_LEVEL TP,VOL_BAR5,Volume5

    NewVolume = 6
    (* VOLUME 6 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX6_UP_BTN, MIX6_DWN_BTN, MUTE6_BTN, 0, 6, SrmOut,
                              Volume6, OldVolume6, OldCalVolume6, 0, NewVolume)
    IF( NewVolume)
      SEND_LEVEL TP,VOL_BAR6,Volume6

    NewVolume = 7
    (* Master *)
    SYSTEM_CALL 'SrmVols'(TP, MASTER_UP_BTN, MASTER_DWN_BTN, MUTE7_BTN, 0, 7, SrmOut,
                              Master, Oldmaster, OldCalMaster, 0, NewVolume)
    IF( NewVolume)
      SEND_LEVEL TP,VOL_BAR7,Master
    SRMreqPramReady = 0
  } (* End Level Page *)
(******************* Control Page ******************************)
  IF ([TP,CONTROL_BTN])
  {
  (*  SRMmemReady = 1 *)
    IF (SRMgroupReady)
    {
      SRMgroupReady = 0
      SRMgroupLevel = LEFT_STRING (SRMgroupLevel, 6)
      CALL 'SetGrpLevels'
    }
    NewVolume = 1
    (* Group 1 *)   (* TP,Up Btn,Dwn Btn,Mute Btn,UnMute Btn,SRM In,SRM Out,Volume,OldVolume,OldCalVolume,Groups,V# *)
                                (*  Set UnMute to 0 to use Mute as Toggle              *)
    SYSTEM_CALL 'SrmVols'(TP, MIX1_UP_BTN, MIX1_DWN_BTN, MUTE1_BTN, 0, 0, 0,
                              Volume1, OldVolume1, OldCalVolume1, 1, NewVolume)
    IF (NewVolume)
      SEND_LEVEL TP,VOL_BAR1,Volume1

    NewVolume = 2
    (* Group 2 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX2_UP_BTN, MIX2_DWN_BTN, MUTE2_BTN, 0, 0, 0,
                              Volume2, OldVolume2, OldCalVolume2, 2, NewVolume)
    IF (NewVolume)
      SEND_LEVEL TP,VOL_BAR2,Volume2

    NewVolume = 3
    (* Group 3 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX3_UP_BTN, MIX3_DWN_BTN, MUTE3_BTN, 0, 0, 0,
                              Volume3, OldVolume3, OldCalVolume3, 3, NewVolume)
    IF (NewVolume)
      SEND_LEVEL TP,VOL_BAR3,Volume3

    NewVolume = 4
    (* Group 4 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX4_UP_BTN, MIX4_DWN_BTN, MUTE4_BTN, 0, 0, 0,
                              Volume4, OldVolume4, OldCalVolume4, 4, NewVolume)
    IF (NewVolume)
      SEND_LEVEL TP,VOL_BAR4,Volume4

    NewVolume = 5
    (* Group 5 *)
    SYSTEM_CALL 'SrmVols'(TP, MIX5_UP_BTN, MIX5_DWN_BTN, MUTE5_BTN, 0, 0, 0,
                              Volume5, OldVolume5, OldCalVolume5, 5, NewVolume)
    IF (NewVolume)
      SEND_LEVEL TP,VOL_BAR5,Volume5

    NewVolume = 6
    (* Group 6 *)
    SYSTEM_CALL[6] 'SrmVols'(TP, MIX6_UP_BTN, MIX6_DWN_BTN, MUTE6_BTN, 0, 0, 0,
                                 Volume6, OldVolume6, OldCalVolume6, 6, NewVolume)
    IF (NewVolume)
      SEND_LEVEL TP,VOL_BAR6,Volume6

   (* Memory Recall *)
    IF (SRMmemReady) {
      SRMmemReady = 0
      SELECT {
        ACTIVE (SRMmemory = 1) :
          ON [TP,MEM_SELECT1_BTN]
        ACTIVE (SRMmemory = 2) :
          ON [TP,MEM_SELECT2_BTN]
        ACTIVE (SRMmemory = 3) :
          ON [TP,MEM_SELECT3_BTN]
        ACTIVE (SRMmemory = 4) :
          ON [TP,MEM_SELECT4_BTN]
        ACTIVE (SRMmemory = 5) :
          ON [TP,MEM_SELECT5_BTN]
        ACTIVE (SRMmemory = 6) :
          ON [TP,MEM_SELECT6_BTN]
        ACTIVE (SRMmemory = 7) :
          ON [TP,MEM_SELECT7_BTN]
        ACTIVE (SRMmemory = 8) :
          ON [TP,MEM_SELECT8_BTN]
        ACTIVE (SRMmemory = 9) :
          ON [TP,MEM_SELECT9_BTN]
        ACTIVE (SRMmemory = 10) :
          ON [TP,MEM_SELECT10_BTN]
        ACTIVE (SRMmemory = 11) :
          ON [TP,MEM_SELECT11_BTN]
        ACTIVE (SRMmemory = 12) :
          ON [TP,MEM_SELECT12_BTN]
        ACTIVE (SRMmemory = 13) :
          ON [TP,MEM_SELECT13_BTN]
        ACTIVE (SRMmemory = 14) :
          ON [TP,MEM_SELECT14_BTN]
        ACTIVE (SRMmemory = 15) :
          ON [TP,MEM_SELECT15_BTN]
        ACTIVE (SRMmemory = 16) :
          ON [TP,MEM_SELECT16_BTN]
        ACTIVE (SRMmemory = 17) :
          ON [TP,MEM_SELECT17_BTN]
        ACTIVE (SRMmemory = 18) :
          ON [TP,MEM_SELECT18_BTN]
        ACTIVE (SRMmemory = 19) :
          ON [TP,MEM_SELECT19_BTN]
        ACTIVE (SRMmemory = 20) :
          ON [TP,MEM_SELECT20_BTN]
        ACTIVE (SRMmemory = 21) :
          ON [TP,MEM_SELECT21_BTN]
        ACTIVE (SRMmemory = 22) :
          ON [TP,MEM_SELECT22_BTN]
        ACTIVE (SRMmemory = 23) :
          ON [TP,MEM_SELECT23_BTN]
        ACTIVE (SRMmemory = 24) :
          ON [TP,MEM_SELECT24_BTN]
      }
    }

    PUSH [TP,MEM_SELECT1_BTN]
    {
      ON [TP,MEM_SELECT1_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 1, "0")
      SRMmemory = 1
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT2_BTN]
    {
      ON [TP,MEM_SELECT2_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 2, "0")
      SRMmemory = 2
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT3_BTN]
    {
      ON [TP,MEM_SELECT3_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 3, "0")
      SRMmemory = 3
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT4_BTN]
    {
      ON [TP,MEM_SELECT4_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 4, "0")
      SRMmemory = 4
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT5_BTN]
    {
      ON [TP,MEM_SELECT5_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 5, "0")
      SRMmemory = 5
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT6_BTN]
    {
      ON [TP,MEM_SELECT6_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 6, "0")
      SRMmemory = 6
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT7_BTN]
    {
      ON [TP,MEM_SELECT7_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 7, "0")
      SRMmemory = 7
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT8_BTN]
    {
      ON [TP,MEM_SELECT8_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 8, "0")
      SRMmemory = 8
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT9_BTN]
    {
      ON [TP,MEM_SELECT9_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 9, "0")
      SRMmemory = 9
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT10_BTN]
    {
      ON [TP,MEM_SELECT10_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 10, "0")
      SRMmemory = 10
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT11_BTN]
    {
      ON [TP,MEM_SELECT11_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 11, "0")
      SRMmemory = 11
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT12_BTN]
    {
      ON [TP,MEM_SELECT12_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 12, "0")
      SRMmemory = 12
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT13_BTN]
    {
      ON [TP,MEM_SELECT13_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 13, "0")
      SRMmemory = 13
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT14_BTN]
    {
      ON [TP,MEM_SELECT14_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 14, "0")
      SRMmemory = 14
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT15_BTN]
    {
      ON [TP,MEM_SELECT15_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 15, "0")
      SRMmemory = 15
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT16_BTN]
    {
      ON [TP,MEM_SELECT16_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 16, "0")
      SRMmemory = 16
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT17_BTN]
    {
      ON [TP,MEM_SELECT17_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 17, "0")
      SRMmemory = 17
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT18_BTN]
    {
      ON [TP,MEM_SELECT18_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 18, "0")
      SRMmemory = 18
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT19_BTN]
    {
      ON [TP,MEM_SELECT19_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 19, "0")
      SRMmemory = 19
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT20_BTN]
    {
      ON [TP,MEM_SELECT20_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 20, "0")
      SRMmemory = 20
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT21_BTN]
    {
      ON [TP,MEM_SELECT21_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 21, "0")
      SRMmemory = 21
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT22_BTN]
    {
      ON [TP,MEM_SELECT22_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 22, "0")
      SRMmemory = 22
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT23_BTN]
    {
      ON [TP,MEM_SELECT23_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 23, "0")
      SRMmemory = 23
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,MEM_SELECT24_BTN]
    {
      ON [TP,MEM_SELECT24_BTN]
                          (* Command, Memory#, 0 *)
      SYSTEM_CALL 'SRM_Q' (SRM_RECALL_MEM, 24, "0")
      SRMmemory = 24
      WAIT 1
        CALL 'UpdateMemory'
    }

    PUSH [TP,SELECT_OUT_GROUP_BTN]
    {
      ON [TP,SELECT_OUT_GROUP_BTN]
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_GROUP_LEVELS,0,"6")
      SEND_COMMAND TP,"'ICON1-14'"
      SEND_COMMAND TP,"'FONT1-3'"
      SEND_COMMAND TP,"'TEXT1-Output'"
      SEND_COMMAND TP,"'ICON2-14'"
      SEND_COMMAND TP,"'FONT2-3'"
      SEND_COMMAND TP,"'TEXT2-Group'"
      InSelect = 1
      OutSelect = 0
      CALL 'ClearAllInputs'
      ON [TP,OUT_SELECT_CLEAR]
    }

    PUSH [TP,SELECT_RMT_GROUP_BTN]
    {
      ON [TP,SELECT_RMT_GROUP_BTN]
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_GROUP_LEVELS,0,"6")
      SEND_COMMAND TP,"'ICON1-14'"
      SEND_COMMAND TP,"'FONT1-3'"
      SEND_COMMAND TP,"'TEXT1-Remote'"
      SEND_COMMAND TP,"'ICON2-14'"
      SEND_COMMAND TP,"'FONT2-3'"
      SEND_COMMAND TP,"'TEXT2-Group'"
      InSelect = 1
      OutSelect = 0
      CALL 'ClearAllInputs'
      ON [TP,OUT_SELECT_CLEAR]
    }
    IF (InSelect)
    {
      PUSH [TP,IN_SELECT1_BTN]
      {
        IF (![TP,SELECT_ROUTE_BTN])
        {
          CALL 'ClearAllInputs'
          ON [TP,IN_SELECT1_BTN]
          IF ([TP,SELECT_OUT_GROUP_BTN])
            CALL 'DisplayGroup'(OutSRMgroup[1])
          ELSE
            CALL 'DisplayGroup'(SR1Group[1])
        }
        ELSE
        {
          ON [TP,IN_SELECT1_BTN]
          InputSelect = InputSelect | 1
        }
        InputSelect = 1
        OutSelect = 1
      }

      PUSH [TP,IN_SELECT2_BTN]
      {
        IF (![TP,SELECT_ROUTE_BTN])
        {
          CALL 'ClearAllInputs'
          ON [TP,IN_SELECT2_BTN]
          IF ([TP,SELECT_OUT_GROUP_BTN])
            CALL 'DisplayGroup'(OutSRMgroup[2])
          ELSE
            CALL 'DisplayGroup'(SR1Group[2])
        }
        ELSE
        {
          ON [TP,IN_SELECT2_BTN]
          InputSelect = InputSelect | 2
        }
        InputSelect = 2
        OutSelect = 1
      }

      PUSH [TP,IN_SELECT3_BTN]
      {
        IF (![TP,SELECT_ROUTE_BTN])
        {
          CALL 'ClearAllInputs'
          ON [TP,IN_SELECT3_BTN]
          IF ([TP,SELECT_OUT_GROUP_BTN])
            CALL 'DisplayGroup'(OutSRMgroup[3])
          ELSE
            CALL 'DisplayGroup'(SR1Group[3])
        }
        ELSE
        {
          InputSelect = InputSelect | 4
          ON [TP,IN_SELECT3_BTN]
        }
        InputSelect = 3
        OutSelect = 1
      }

      PUSH [TP,IN_SELECT4_BTN]
      {
        IF (![TP,SELECT_ROUTE_BTN])
        {
          CALL 'ClearAllInputs'
          ON [TP,IN_SELECT4_BTN]
          IF ([TP,SELECT_OUT_GROUP_BTN])
            CALL 'DisplayGroup'(OutSRMgroup[4])
          ELSE
            CALL 'DisplayGroup'(SR1Group[4])
        }
        ELSE
        {
          InputSelect = InputSelect |  8
          ON [TP,IN_SELECT4_BTN]
        }
        InputSelect = 4
        OutSelect = 1
      }

      PUSH [TP,IN_SELECT5_BTN]
      {
        IF (![TP,SELECT_ROUTE_BTN])
        {
          CALL 'ClearAllInputs'
          ON [TP,IN_SELECT5_BTN]
          IF ([TP,SELECT_OUT_GROUP_BTN])
            CALL 'DisplayGroup'(OutSRMgroup[5])
          ELSE
            CALL 'DisplayGroup'(SR1Group[5])
        }
        ELSE
        {
          InputSelect = InputSelect | 16
          ON [TP,IN_SELECT5_BTN]
        }
        InputSelect = 5
        OutSelect = 1
      }

      PUSH [TP,IN_SELECT6_BTN]
      {
        IF (![TP,SELECT_ROUTE_BTN])
        {
          CALL 'ClearAllInputs'
          ON [TP,IN_SELECT6_BTN]
          IF ([TP,SELECT_OUT_GROUP_BTN])
            CALL 'DisplayGroup'(OutSRMgroup[6])
          ELSE
            CALL 'DisplayGroup'(SR1Group[6])
        }
        ELSE
        {
          InputSelect = InputSelect | 32
          ON [TP,IN_SELECT6_BTN]
        }
        InputSelect = 6
        OutSelect = 1
      }

      IF ([TP,SELECT_RMT_GROUP_BTN])
      {
        PUSH [TP,IN_MASTER_BTN]
        {
          CALL 'ClearAllInputs'
          ON [TP,IN_MASTER_BTN]
          CALL 'DisplayGroup'(SR1Group[7])
          InputSelect = 7
          OutSelect = 1
        }
      }
    }  (* End InSelect *)


    IF (OutSelect)
    {
      PUSH [TP,OUT_SELECT1_BTN]
      {
        InSelect = 1
        NewOutput = 1
        IF (!([TP,OUT_SELECT1_BTN]))
        {
          NewGroup = 1
          ON [TP,OUT_SELECT1_BTN]
        }
        ELSE
        {
          NewGroup = 0
          ON [TP,OUT_SELECT_CLEAR]
        }
      }

      PUSH [TP,OUT_SELECT2_BTN]
      {
        InSelect = 1
        NewOutput = 1
        IF (!([TP,OUT_SELECT2_BTN]))
        {
          NewGroup = 2
          ON [TP,OUT_SELECT2_BTN]
        }
        ELSE
        {
          NewGroup = 0
          ON [TP,OUT_SELECT_CLEAR]
        }
      }

      PUSH [TP,OUT_SELECT3_BTN]
      {
        InSelect = 1
        NewOutput = 1
        IF (!([TP,OUT_SELECT3_BTN]))
        {
          NewGroup = 3
          ON [TP,OUT_SELECT3_BTN]
        }
        ELSE
        {
          NewGroup = 0
          ON [TP,OUT_SELECT_CLEAR]
        }
      }

      PUSH [TP,OUT_SELECT4_BTN]
      {
        InSelect = 1
        NewOutput = 1
        IF (!([TP,OUT_SELECT4_BTN]))
        {
          NewGroup = 4
          ON [TP,OUT_SELECT4_BTN]
        }
        ELSE
        {
          NewGroup = 0
          ON [TP,OUT_SELECT_CLEAR]
        }
      }

      PUSH [TP,OUT_SELECT5_BTN]
      {
        InSelect = 1
        NewOutput = 1
        IF (!([TP,OUT_SELECT5_BTN]))
        {
          NewGroup = 5
          ON [TP,OUT_SELECT5_BTN]
        }
        ELSE
        {
          NewGroup = 0
          ON [TP,OUT_SELECT_CLEAR]
        }
      }

      PUSH [TP,OUT_SELECT6_BTN]
      {
        InSelect = 1
        NewOutput = 1
        IF (!([TP,OUT_SELECT6_BTN]))
        {
          NewGroup = 6
          ON [TP,OUT_SELECT6_BTN]
        }
        ELSE
        {
          NewGroup = 0
          ON [TP,OUT_SELECT_CLEAR]
        }
      }

      IF ([TP,SELECT_RMT_GROUP_BTN])
      {
        PUSH [TP,OUT_MASTER_BTN]
        {
          InSelect = 1
          NewOutput = 1
          IF (!([TP,OUT_MASTER_BTN]))
          {
            NewGroup = 7
            ON [TP,OUT_MASTER_BTN]
          }
          ELSE
          {
            NewGroup = 0
            ON [TP,OUT_SELECT_CLEAR]
          }
        }
      }
    }  (* End OutSelect *)

    IF (NewOutput && [TP,SELECT_OUT_GROUP_BTN])
    {
      CAll 'SendOutGroup'
                         (* Command, Index, Data Count *)
      SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }

    IF (NewOutput && [TP,SELECT_RMT_GROUP_BTN])
    {
#IF_DEFINED INCLUDE_SR1
      StopSR1 = 10
      CAll 'SendSR1Group'
#END_IF
                        (* Command, Index, Data Count *)
    SYSTEM_CALL 'SRM_Q' (SRM_REQ_PARAM,0,"SRM_PARAM_LEN")
    }
  } (* End Control Page *)

(* Send a block of data *)
  PUSH [TP,LOAD_SRM_BTN]
  { (* Only Send a maximum of 64 bytes *)
    (* Note - The the AXC-232 ESC command 'RXON' 27,17,<time>" in Out 2 and Out 4 will not cause the AXC-232 *)
    (*        to perform the feature. DoSRM fixes this problem (See Axcess Cards AXC-232 *)
                          (* Command, Index, Data *)
    SYSTEM_CALL 'SRM_Q' (SRM_SEND_PARAM,0,"6,6,6,ESC,17,6,SRM_IN_MASTER,SRM_IN_LIMITER,
                              (*Out 2*)    6,6,6,6,6,6,SRM_IN_MASTER,SRM_IN_LIMITER,
                              (*Out 3*)    6,6,6,6,6,6,SRM_IN_MASTER,SRM_IN_LIMITER,
                              (*Out 4*)    6,6,6,6,6,6,SRM_IN_MASTER,SRM_IN_LIMITER,
                              (*Out 5*)    6,6,ESC,18,6,6,SRM_IN_MASTER,SRM_IN_LIMITER,
                              (*Out 6*)    32,32,32,32,32,32,SRM_IN_MASTER,ESC")

  }
}   (* End SystemReady *)

(* StopOpstat = 1 *)
IF (SystemOn)
{
(* Device SRM, Device SR1 or 0, Set to 1 if using Axcess without DSC1, Set to 0 if using Netlinx *)
(* SYSTEM_CALL 'DoSRM' (SRM,0,1) No SR1 *)
  SYSTEM_CALL 'DoSRM' (SRM,SR1,1)
}

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

